#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "hpu2program4xi5test.py">
#<abstract4xi abstract = "tests hpu2program4xi.py"/>
#<verify4xi verification = "11" target = "hpu2program4xi.py"/>
#<contextualize4xi context = "program4xi.py"/>
##<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = ['hpu2program4xi5test'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/> 

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from pipe4xi import Pipe4Xi   
from platformids4xi import get2platformids4xi
from queue4xi import Queue4Xi

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from hpu2commandqueue4xi import HPU2CommandQueue4Xi
from hpu2commandqueue4xi import create2commandqueue4hpu 
from hpu2commandqueue4xi import flush2commandqueue4hpu
from hpu2commandqueue4xi import finish2commandqueue4hpu
from hpu2commandqueue4xi import get2commandqueueinfo4hpu
from hpu2commandqueue4xi import release2commandqueue4hpu
from hpu2commandqueue4xi import retain2commandqueue4hpu
from hpu2commandqueue4xi import set2commandqueue4hpu
from hpu2commandqueue4xi import trace2commandqueue4hpu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from hpu2context4xi import HPU2Context4Xi 
from hpu2context4xi import create2context4hpu
from hpu2context4xi import get2context4hpu
from hpu2context4xi import release2context4hpu
from hpu2context4xi import retain2context4hpu
from hpu2context4xi import set2context4hpu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from hpu2device4xi import HPU4Xi
from hpu2device4xi import init2hpu4xi 
from hpu2device4xi import set2hpu4xi
from hpu2device4xi import get2hpu4xi


# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from hpu2event4xi import HPU2Event4Xi
from hpu2event4xi import create2event4hpu
from hpu2event4xi import get2eventinfo4hpu
from hpu2event4xi import release2event4hpu
from hpu2event4xi import retain2event4hpu
from hpu2event4xi import set2eventcallback4hpu 
from hpu2event4xi import set2event4hpu
from hpu2event4xi import trace2event4hpu
from hpu2event4xi import wait2event4hpu

# -------------------------------------------------------------------------------------------------
# Image module                           
# -------------------------------------------------------------------------------------------------
from hpu2image4xi import HPU2Image4Xi
from hpu2image4xi import create2image4hpu
from hpu2image4xi import get2imageinfo4hpu
from hpu2image4xi import get2supportedimageformats4hpu
from hpu2image4xi import manoeuvre2copyimage4hpu
from hpu2image4xi import manoeuvre2copyimagetobuffer4hpu
from hpu2image4xi import manoeuvre2copybuffertoimage4hpu
from hpu2image4xi import manoeuvre2readimage4hpu
from hpu2image4xi import manoeuvre2writeimage4hpu
from hpu2image4xi import manoeuvre2mapimage4hpu
from hpu2image4xi import copy2image4hpu
from hpu2image4xi import copy2imagetobuffer4hpu
from hpu2image4xi import copy2buffertoimage4hpu
from hpu2image4xi import read2image4hpu
from hpu2image4xi import map2image4hpu
from hpu2image4xi import release2image4hpu
from hpu2image4xi import retain2image4hpu
from hpu2image4xi import set2imagecallback4hpu 
from hpu2image4xi import set2image4hpu
from hpu2image4xi import trace2image4hpu
from hpu2image4xi import wait2image4hpu
from hpu2image4xi import write2image4hpu

# -------------------------------------------------------------------------------------------------
# Program module                           
# -------------------------------------------------------------------------------------------------
from hpu2program4xi import HPU2Program4Xi
from hpu2program4xi import add2programwithsource4hpu
from hpu2program4xi import add2programwithbinary4hpu
from hpu2program4xi import build2program4hpu
from hpu2program4xi import compile2program4hpu
from hpu2program4xi import create2programwithsource4hpu
from hpu2program4xi import create2programwithbinary4hpu
from hpu2program4xi import delete2programwithsource4hpu
from hpu2program4xi import delete2programwithbinary4hpu
from hpu2program4xi import get2programinfo4hpu
# from hpu2program4xi import get2programbuildinfo4hpu
from hpu2program4xi import link2program4hpu
from hpu2program4xi import release2program4hpu
from hpu2program4xi import retain2program4hpu
from hpu2program4xi import set2programcallback4hpu 
from hpu2program4xi import set2programwithsource4hpu
from hpu2program4xi import set2programwithbinary4hpu
from hpu2program4xi import trace2program4hpu
# from hpu2program4xi import unload2compiler4hpu

# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi

# -------------------------------------------------------------------------------------------------
# Trace modules                    
# -------------------------------------------------------------------------------------------------

                                                                                                                  # REMEMBER TO MODIFY NECESSARY MODULES BEFORE TESTS !!
                                                                                                                  
from print4xi import Print4Xi                                                                                     # edit print4xi.py - embeds trace for the functions and classes to be tested
from print4xi import print4xi                                                                                     # see OpenCl4Xi definitions in print4xi.py

from pickle4xi import pickle4xi                                                                                   # edit corresponding pickle2?4xi.py
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 

    
from actor2a4xi import Actor2a4Xi                                                                                   # define functions and class for zapping 
from actor2b4xi import Actor2b4Xi                                                                                   # not necessary for testing but got to be done later on!
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from time4xi import time4xi                                                                                         # time stamp to events

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   # XML trace
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global folder2lib4hpu                                                   # Folder of HPU library
global kb2fetch4hpu                                                     # Knowledgebase for fetching
global KB4Focus                                                         # Focus knowledgebase
global profile2fetch4source                                             # Extension for source files
global profile2fetch4binary                                             # Extension for binary files

global PickleKB4Xi
global t2xi                                                             # Print4Xi object for trace
    
# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
temp2hpu = 'hpu'
key2dir = temp2hpu[0]                                    # MORE COMPLIATED WAY DUE TO AUTOMATIC SOFTWARE GENERATION
folder2lib4hpu = VersionKB4Xi[key2dir] 

KB4Focus = {                                             #  NACK= Focus; (01) = first focus (02) = second focus etc                                      
         'add2programwithsource4hpu':         'ACK4XI',  # (FOCUS 04) 
         'add2programwithbinary4hpu':         'ACK4XI',  # (FOCUS 08)         
         'build2program4hpu':                 'ACK4XI',  # (FOCUS 19)
         'compile2program4hpu':               'ACK4XI',  # (FOCUS 02)
         'create2programwithsource4hpu':      'NACK4XI',  # (FOCUS 01) - CREATE FUNCTION IS REQUIRED TO TEST SOME OTHER FUNCTIONS!
         'create2programwithbinary4hpu':      'ACK4XI',  # (FOCUS 07)
         'delete2programwithsource4hpu':      'ACK4XI',  # (FOCUS 05)
         'delete2programwithbinary4hpu':      'ACK4XI',  # (FOCUS 09)              
         'get2programinfo4hpu':               'ACK4XI',  # (FOCUS 06,10,11) needed by other 
         'get2programbuildinfo4hpu':          'ACK4XI',
         'link2program4hpu':                  'ACK4XI',  # (FOCUS 03)         
         'release2program4hpu':               'ACK4XI',  # (FOCUS 15)
         'retain2program4hpu':                'ACK4XI',  # (FOCUS 16)         
         'set2programcallback4hpu':           'ACK4XI',  # (FOCUS 17)
         'set2programwithsource4hpu':         'ACK4XI',  # (FOCUS 12)
         'set2programwithbinary4hpu':         'ACK4XI',  # (FOCUS 14)     
         'trace2program4hpu':                 'ACK4XI',  # (FOCUS 18)
         'unload2compiler4hpu':               'ACK4XI',
         'HPU2Program4Xi':                    'ACK4XI',  # (FOCUS 110) - CLASS  - MANDATORY TO HAVE ANY METHOD IN FOCUS - __INIT__ calls create2programwithsource !
         'add2programwithsource':             'ACK4XI',  # (FOCUS 122)  
         'add2programwithbinary':             'ACK4XI',  # (FOCUS 132)         
         'build2program':                     'ACK4XI',  # (FOCUS 240)
         'compile2program':                   'ACK4XI',  # (FOCUS 121A)
         'create2programwithsource':          'ACK4XI',  # (FOCUS 190)
         'create2programwithbinary':          'ACK4XI',  # (FOCUS 130)
         'delete2programwithsource':          'ACK4XI',  # (FOCUS 124)  
         'delete2programwithbinary':          'ACK4XI',  # (FOCUS 134)             
         'get2programinfo':                   'ACK4XI',  # (FOCUS 140) - USEFUL FOR SEVERAL FOCUS
         'get2programbuildinfo':              'ACK4XI',  #
         'link2program':                      'ACK4XI',  # (FOCUS 121C)         
         'release2program':                   'ACK4XI',  # (FOCUS 170,220)
         'retain2program':                    'ACK4XI',  # (FOCUS 180,230)         
         'set2programcallback':               'ACK4XI',  # (FOCUS 200) 
         'set2programwithsource':             'ACK4XI',  # (FOCUS 150) 
         'set2programwithbinary':             'ACK4XI',  # (FOCUS 160)          
         'trace2program':                     'ACK4XI',  # (FOCUS 210)
         'unload2compiler':                   'ACK4XI',  #
         'sense':                             'ACK4XI',  # (FOCUS 310)
         'reason':                            'ACK4XI',  # (FOCUS 320)
         'ace':                               'ACK4XI'   # (FOCUS 330)                                    
        }                                                # TIP: SEARCH WITH FOCUS NN IN TEST OUT FILE, WHERE NN = 01,02 ...                    

profile2fetch4source = '.py'                                            # Example extensions: '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C
profile2fetch4binary = '.pyc'                                           #  

kb2fetch4hpu = {}                                                       # Programs to be fetched                                
kb2fetch4hpu[1] = 'hpu2sampler4xi5test.py'                              # source
kb2fetch4hpu[2] = 'hpu2sampler4xi5test.cpython-33.pyc'                  # binary

# kb2fetch4hpu[3] = 'hpu2image4xi5test.py'
# kb2fetch4hpu[4] = 'hpu2image4xi5test.cpython-33.pyc'
# kb2fetch4hpu[5] = 'hpu3image4xi5test.py'
# kb2fetch4hpu[6] = 'hpu3image4xi5test.cpython-33.pyc'
# kb2fetch4hpu[7] = 'hpu2commandqueue4xi5test.py'
# kb2fetch4hpu[8] = 'hpu2commandqueue4xi5test.cpython-33.pyc'
# kb2fetch4hpu[9] = 'hpu2event4xi5test.py'
# kb2fetch4hpu[10] = 'hpu2event4xi5test.cpython-33.pyc'

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       # 
       'b': Pickle2b4Xi,
       # 
       'c': Pickle2c4Xi,
       # 
       'd': Pickle2d4Xi,
       # 
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'HPU2Program4Xi':                    'NACK4XI',  # class     - all methods will be traced
         'add2programwithsource4hpu':         'NACK4XI',  # functions - only selected ones will be traced
         'add2programwithbinary4hpu':         'NACK4XI',         
         'build2program4hpu':                 'NACK4XI',
         'compile2program4hpu':               'NACK4XI',  
         'create2programwithsource4hpu':      'NACK4XI',  
         'create2programwithbinary4hpu':      'NACK4XI',
         'delete2programwithsource4hpu':      'NACK4XI',
         'delete2programwithbinary4hpu':      'NACK4XI',             
         'fetch2programsource4hpu':           'NACK4XI',
         'fetch2programbinary4hpu':           'NACK4XI',         
         'get2programinfo4hpu':               'NACK4XI',
         'get2programbuildinfo4hpu':          'NACK4XI',
         'link2program4hpu':                  'NACK4XI',         
         'release2program4hpu':               'NACK4XI',
         'retain2program4hpu':                'NACK4XI',         
         'set2programcallback4hpu':           'NACK4XI',
         'set2programwithsource4hpu':         'NACK4XI',
         'set2programwithbinary4hpu':         'NACK4XI',          
         'trace2program4hpu':                 'NACK4XI',
         'unload2compiler4hpu':               'NACK4XI',
         'create2sampler4hpu':                'NACK4XI',  # activated target function trace! 
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #
    
#</function4xi>             

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
#   print XML trace for program4hpu test
#"> 
# -------------------------------------------------------------------------------------------------    
def print2trace4xi(t2xi):

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\sense-hpu2program4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourhpuxi.org/sw4xi/python33/owl/multiprocessing4hpu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourhpuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Program of HPU.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Program of HPU sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\reason-hpu2program4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourhpuxi.org/sw4xi/python33/owl/multiprocessing4hpu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourhpuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Program of HPU.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\ace-hpu2program4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourhpuxi.org/sw4xi/python33/owl/multiprocessing4hpu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourhpuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Program of HPU.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of Program of HPU.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "hpu2program4xi5test" usage = "
#   tests program4hpu
#"> 
# -------------------------------------------------------------------------------------------------    
def hpu2program4xi5test():
    global KB4Focus
    global folder2lib4hpu

    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0A/33) OF TEST_RESOURCESHARER4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:

        # ---------------------------------------------------------------------------------------------
        # START TESTING                          
        # ---------------------------------------------------------------------------------------------    
        print('(Step 1A/700) OF HPU2PROGRAM4XI5TEST - STARTED ', time4xi()) 

        # =============================================================================================
        # FUNCTION TESTS CLASS TESTS
        # =============================================================================================          
        print('JATKA')
        print('FOCUS 01')
        if KB4Focus['create2programwithsource4hpu'] == 'NACK4XI':              
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - CREATE PROGRAM OBJECT WITH SOURCE USING FUNCTION                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2A1/700) OF HPU2PROGRAM4XI5TEST - TRYING TO CREATE PROGRAM SOURCE FOR HPU ', time4xi())       
            try:
                response4create2programwithsource = create2programwithsource4hpu()
                keys2response4create = response4create2programwithsource.keys()
                print('(Step 2A2/700) OF HPU2PROGRAM4XI5TEST - CREATED PROGRAM SOURCE FOR HPU ', keys2response4create) 
                # ['CODE2ERROR',
                #  'COUNT2REFERENCE',
                #  'DATA2CALLBACK',
                #  'BUFFER',
                #  'FUNCTION2CALLBACK',
                #  'ACK2RETURN',
                #  'QUEUE',
                #  'PLATFORM',
                #  'NACK2RETURN',
                #  'CONTEXT',
                #  'COMMANDQUEUE',
                #  'DEVICE',
                #  'EVENT',
                #  'PIPE'])

            except:
                print('(Step 2Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO CREATE PROGRAM SOURCE FOR HPU *** ', time4xi())
            try:                                                                                      
                print('COUNT4SOURCE: ', response4create2programwithsource['COUNT4SOURCE'])
                print('DIRECTORY4SOURCE: ', response4create2programwithsource['DIRECTORY4SOURCE'])
                print('LANGUAGE4SOURCE: ', response4create2programwithsource['LANGUAGE4SOURCE'])
                print('SIZE4SOURCE: ', response4create2programwithsource['SIZE4SOURCE'])
                keys2source = response4create2programwithsource['CODE4SOURCE'].keys()
                for key2source in keys2source:
                    print('SOURCE: ', key2source)
                    print(response4create2programwithsource ['CODE4SOURCE'] [key2source] [1])
                    print(response4create2programwithsource ['CODE4SOURCE'] [key2source] [3])
                    print(response4create2programwithsource ['CODE4SOURCE'] [key2source] [4])
                    print(response4create2programwithsource ['CODE4SOURCE'] [key2source] [5])
                #OK:    
                # COUNT4SOURCE:  1
                # DIRECTORY4SOURCE:  folder2lib4hpu
                # LANGUAGE4SOURCE:  Python
                # SIZE4SOURCE:  {folder2lib4hpu + 'hpu2sampler4xi5test.py': 1337}
                # SOURCE:  folder2lib4hpu + 'hpu2sampler4xi5test.py'
                # #<profile4xi profile = "11" />
                # #<program4xi program = "hpu2sampler4xi5test.py">
                # #<abstract4xi abstract = "tests hpu2sampler4xi.py"/>
                # #<verify4xi verification = "11" target = "hpu2sampler4xi.py"/> 
                
                     
            except:
                print('(Step 2Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4create2programwithsource *** ', response4create2programwithsource)
        else:
            pass                                                                                                    # NOT IN FOCUS
                                       
        print('FOCUS 02')  
        if KB4Focus['compile2program4hpu'] == 'NACK4XI':
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - COMPILE SOURCE INTO PROGRAM OBJECT WITH FUNCTION                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2A2/700) OF HPU2PROGRAM4XI5TEST - TRYING TO COMPILE SOURCE INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())           
            try:
                response4compile = compile2program4hpu()
            except:
                print('(Step 2Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO COMPILE SOURCE INTO PROGRAM OBJECT WITH FUNCTION *** ', time4xi())                                                                      
            try:
                print('(Step 2B2/700) OF HPU2PROGRAM4XI5TEST - RESPONSE4COMPILE: ', time4xi())                                                                                      
                keys2response4compile = response4compile.keys()
                for key2response4compile in keys2response4compile:
                    print('KEY2RESPONSE4COMPILE: ', key2response4compile)
                    # hpu2sampler4xi5test.py            
            except:
                print('(Step 2Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4compile *** ', response4compile)
            tailor2trace4program(t2xi)                                                                              # TAILOR TRACE AGAIN - TARGET FUNCTIONS OF ACTIVATED PROCESSES MIGHT HAVE RESET TRACE !    
        else:
            pass 
                                                                                                                    # NOT IN FOCUS
        print('FOCUS 03')                       
        if KB4Focus['link2program4hpu'] == 'NACK4XI':        
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - LINK INSIDE PROGRAM OBJECT WITH FUNCTION                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2AB2/700) OF HPU2PROGRAM4XI5TEST - TRYING TO LINK INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())           
            try:
                response4link = link2program4hpu()
                print('(Step 2BB2/700) OF HPU2PROGRAM4XI5TEST - LINKED INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi()) 
            except:
                print('(Step 2Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO LINK INSIDE PROGRAM OBJECT WITH FUNCTION *** ', time4xi())                                                                     
            try:
                print('(Step CC2/700) OF HPU2PROGRAM4XI5TEST - response4link:') 
                keys2response = response4link.keys()
                for key2response in sorted(keys2response):
                    print(key2response, ' : ', response4link[key2response])
                    # hpu2sampler4xi5test.py  :  <Process4Xi(Process4Xi-1, stopped[1])>
            except:
                print('(Step 2Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4link *** ', response4link)
            tailor2trace4program(t2xi)                                                                              # TAILOR TRACE AGAIN - TARGET FUNCTIONS OF ACTIVATED PROCESSES MIGHT HAVE RESET TRACE !    
        else:
            pass                                                                                                    # NOT IN FOCUS
         
        print('FOCUS 04')               
        if KB4Focus['add2programwithsource4hpu'] == 'NACK4XI':                 
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - ADD SOURCE INTO PROGRAM OBJECT WITH FUNCTION                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2A3/700) OF HPU2PROGRAM4XI5TEST - TRYING TO ADD SOURCE INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())          
            try:
                task4add2program = {}
                # OK
                task4add2program ['CODE4SOURCE'] = {}
                task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] = {}
                task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] [1] = '#<profile4xi profile = "33" />\n'
                task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] [2] = '#<program4xi program = "hpu2buffer4xi.py" />\n'
                task4add2program ['SIZE4SOURCE'] = {}
                task4add2program ['SIZE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] = len(task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'])
                # NOT OK - EXISTS
                task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2sampler4xi5test.py'] = {}
                task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2sampler4xi5test.py'] [1] = '#<profile4xi profile = "33" />\n'
                task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2sampler4xi5test.py'] [2] = '#<program4xi program = "hpu2sampler4xi5test.py" />\n'
                
                task4add2program ['SIZE4SOURCE'] = {}
                task4add2program ['SIZE4SOURCE'] [folder2lib4hpu + 'hpu2sampler4xi5test.py'] = len(task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2sampler4xi5test.py'])            
                task4add2program ['SIZE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] = len(task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'])            
                
                response4add2programwithsource = add2programwithsource4hpu(task4add2program)
                print('(Step 2A4/700) OF HPU2PROGRAM4XI5TEST - ADDED SOURCE INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())
                #                                                                                   
            except:
                print('(Step 2Z3/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO ADD SOURCE INTO PROGRAM OBJECT WITH FUNCTION *** ', time4xi())
            try:                                                                                      
                print('COUNT4SOURCE: ', response4add2programwithsource['COUNT4SOURCE'])
                print('DIRECTORY4SOURCE: ', response4add2programwithsource['DIRECTORY4SOURCE'])
                print('LANGUAGE4SOURCE: ', response4add2programwithsource['LANGUAGE4SOURCE'])
                print('SIZE4SOURCE: ', response4add2programwithsource['SIZE4SOURCE'])
                keys2source = response4add2programwithsource['CODE4SOURCE'].keys()
                for key2source in keys2source:
                    print('SOURCE: ', key2source)
                    print(response4add2programwithsource ['CODE4SOURCE'] [key2source] [1])
                    # COUNT4SOURCE:  2
                    # DIRECTORY4SOURCE:  folder2lib4hpu
                    # LANGUAGE4SOURCE:  Python
                    # SIZE4SOURCE:  {'folder2lib4hpu + hpu2buffer4xi.py': 2, 'folder2lib4hpu + hpu2sampler4xi5test.py': 1337}
                    # SOURCE:  folder2lib4hpu + hpu2buffer4xi.py
                    # #<profile4xi profile = "33" />
                    # 
                    # SOURCE:  folder2lib4hpu + hpu2sampler4xi5test.py
                    # #<profile4xi profile = "11" />           
            except:
                print('(Step 2Z4/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4add2programwithsource *** ', response4add2programwithsource)                
        else:
            pass                                                                                                    # NOT IN FOCUS
        
        print('FOCUS 05')             
        if KB4Focus['delete2programwithsource4hpu'] == 'NACK4XI':       
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - DELETE SOURCE INTO PROGRAM OBJECT WITH FUNCTION                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2A4/700) OF HPU2PROGRAM4XI5TEST - TRYING TO DELETE SOURCE INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())        
            try:
                task4delete2program = {}
                task4delete2program ['CODE4SOURCE'] = {}
                task4delete2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] = 'Yes'
                task4delete2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2dummy4xi.py'] = 'Yes'
    
                task4delete2program ['SIZE4SOURCE'] = {}
                task4delete2program ['SIZE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] = 'Yes'
                task4delete2program ['SIZE4SOURCE'] [folder2lib4hpu + 'hpu2dummy4xi.py'] = 'Yes'
                
                response4delete2programwithsource = delete2programwithsource4hpu(task4delete2program)
                print('(Step 2A5/700) OF HPU2PROGRAM4XI5TEST - DELETED SOURCE INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())
            except:
                print('(Step 2Z4/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO DELETE SOURCE INTO PROGRAM OBJECT WITH FUNCTION *** ', time4xi()) 
            try:                                                                                      
                print('COUNT4SOURCE: ', response4delete2programwithsource['COUNT4SOURCE'])
                print('DIRECTORY4SOURCE: ', response4delete2programwithsource['DIRECTORY4SOURCE'])
                print('LANGUAGE4SOURCE: ', response4delete2programwithsource['LANGUAGE4SOURCE'])
                print('SIZE4SOURCE: ', response4delete2programwithsource['SIZE4SOURCE'])
                keys2source = response4delete2programwithsource['CODE4SOURCE'].keys()
                for key2source in keys2source:
                    print('SOURCE: ', key2source)
                    print(response4delete2programwithsource ['CODE4SOURCE'] [key2source] [1])
                    # COUNT4SOURCE:  1
                    # DIRECTORY4SOURCE:  OK
                    # LANGUAGE4SOURCE:  Python
                    # SIZE4SOURCE:  {'... //hpu2sampler4xi5test.py': 1337}
                    # SOURCE:  ... //hpu2sampler4xi5test.py
                    # #<profile4xi profile = "11" />       
            except:
                print('(Step 2Z5/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4delete2programwithsource *** ', response4delete2programwithsource)                         
        else:
            pass                                                                                                    # NOT IN FOCUS
        print('FOCUS 06')            
        if KB4Focus['get2programinfo4hpu'] == 'NACK4XI': 
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - GET SOME PROGRAM SOURCE INFO WITH FUNCTION                
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2B1/700) OF HPU2PROGRAM4XI5TEST - TRYING TO GET SOME PROGRAM SOURCE INFO FOR HPU ', time4xi())     
            task4getinfo2program = {}
            task4getinfo2program ['FUNCTION2CALLBACK'] = 'Yes'
            task4getinfo2program ['COUNT4SOURCE'] = 'Yes'
            task4getinfo2program ['DIRECTORY4SOURCE'] = 'Yes'
            task4getinfo2program ['CODE4SOURCE'] = 'Yes'
            task4getinfo2program ['SIZE4SOURCE'] = 'Yes'
            task4getinfo2program ['LANGUAGE4SOURCE'] = 'Yes'
            task4getinfo2program ['COUNT2REFERENCE'] = 'Yes'
            task4getinfo2program ['CODE4SOURCE'] = 'Yes'
            try:
                response4programinfo2hpu = get2programinfo4hpu(task4getinfo2program)
                print('(Step 2B2/700) OF HPU2PROGRAM4XI5TEST - GOT SOME PROGRAM SOURCE INFO FOR HPU ', time4xi())  
            except:
                print('(Step 2Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO GET SOME PROGRAM SOURCE INFO FOR HPU', time4xi())
            try:                                                                                          
                keys2response = response4programinfo2hpu.keys()
                print('COUNT2REFERENCE:', response4programinfo2hpu ['COUNT2REFERENCE'])   
                print('COUNT4SOURCE:', response4programinfo2hpu ['COUNT4SOURCE'])
                print('DIRECTORY4SOURCE:', response4programinfo2hpu ['DIRECTORY4SOURCE']) 
                print('FUNCTION2CALLBACK:', response4programinfo2hpu ['FUNCTION2CALLBACK'])   
                print('LANGUAGE4SOURCE:', response4programinfo2hpu ['LANGUAGE4SOURCE'])
                print('SIZE4SOURCE:', response4programinfo2hpu ['SIZE4SOURCE'])                
                keys2source = response4programinfo2hpu['CODE4SOURCE'].keys()
                for key2source in keys2source:
                    print('SOURCE: ', key2source)
                    print(response4programinfo2hpu ['CODE4SOURCE'] [key2source] [1])
                    # COUNT2REFERENCE: 1
                    # COUNT4SOURCE: 2
                    # DIRECTORY4SOURCE: OK
                    # FUNCTION2CALLBACK: <function trace2program4hpu at 0x0000000003B38AC8>
                    # LANGUAGE4SOURCE: Python
                    # SIZE4SOURCE: {'...//hpu2buffer4xi.py': 2, '...//hpu2sampler4xi5test.py': 1337}
                    # SOURCE:  ...//hpu2buffer4xi.py
                    # #<profile4xi profile = "33" />
                    # SOURCE:  ...//hpu2sampler4xi5test.py
                    # #<profile4xi profile = "11" />                         
            except:
                print('(Step 2Z3/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4programinfo2hpu: ', response4programinfo2hpu)
        else:
            pass                                                                                                    # NOT IN FOCUS
        print('FOCUS 06')               
        if KB4Focus['get2programinfo4hpu'] == 'NACK4XI': 
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - GET ALL PROGRAM SOURCE INFO WITH FUNCTION                
            # ---------------------------------------------------------------------------------------------           
            print('(Step 2C1/700) OF HPU2PROGRAM4XI5TEST - TRYING TO GET ALL PROGRAM SOURCE INFO FOR HPU ', time4xi())      
            try:
                response4getinfo2program = get2programinfo4hpu()
                print('(Step 2C2/700) OF HPU2PROGRAM4XI5TEST - GOT ALL PROGRAM SOURCE INFO FOR HPU ', time4xi())
            except:
                print('(Step 2Z3/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO GET ALL PROGRAM SOURCE INFO FOR HPU ***', time4xi())
            try:                                                                                          
                keys2response = response4getinfo2program.keys()
                for key2response in sorted(keys2response):
                    print(key2response)
                    # ACK2RETURN
                    # BUFFER
                    # CODE2ERROR
                    # CODE4SOURCE
                    # COMMANDQUEUE
                    # CONTEXT
                    # COUNT2REFERENCE
                    # COUNT4SOURCE
                    # DATA2CALLBACK
                    # DEVICE
                    # DIRECTORY4SOURCE
                    # EVENT
                    # FUNCTION2CALLBACK
                    # LANGUAGE4SOURCE
                    # NACK2RETURN
                    # PIPE
                    # PLATFORM
                    # QUEUE
                    # SIZE4SOURCE
                    
            except:
                print('(Step 2Z4/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4getinfo2program: ', response4getinfo2program)
        else:
            pass                                                                                                    # NOT IN FOCUS
              
        print('FOCUS 07') 
        if KB4Focus['create2programwithbinary4hpu'] == 'NACK4XI':   
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - CREATE PROGRAM BINARY WITH FUNCTION                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 3A1/700) OF HPU2PROGRAM4XI5TEST - TRYING TO CREATE PROGRAM BINARY FOR HPU ', time4xi())          
            try:
                response4create2programwithbinary = create2programwithbinary4hpu()
                print('(Step 3A2/700) OF HPU2PROGRAM4XI5TEST - CREATED PROGRAM BINARY FOR HPU ', time4xi())
            except:
                print('(Step 3Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO CREATE PROGRAM BINARY FOR HPU *** ', time4xi())
            try:                                                                                          
                keys2response = response4create2programwithbinary.keys()
                print('COUNT2REFERENCE:', response4create2programwithbinary ['COUNT2REFERENCE'])   
                print('COUNT4BINARY:', response4create2programwithbinary ['COUNT4BINARY'])
                print('DIRECTORY4BINARY:', response4create2programwithbinary ['DIRECTORY4BINARY']) 
                print('FUNCTION2CALLBACK:', response4create2programwithbinary ['FUNCTION2CALLBACK'])   
                print('LANGUAGE4BINARY:', response4create2programwithbinary ['LANGUAGE4BINARY'])
                print('SIZE4BINARY:', response4create2programwithbinary ['SIZE4BINARY'])                
                # COUNT2REFERENCE: 1
                # COUNT4BINARY: 1
                # DIRECTORY4BINARY: ...__pycache__//
                # FUNCTION2CALLBACK: <function trace2program4hpu at 0x0000000003F53AC8>
                # LANGUAGE4BINARY: Python
                # SIZE4BINARY: {'...__pycache__//hpu2image4xi.cpython-33.pyc': 1006}
                keys2source = response4create2programwithbinary['CODE4BINARY'].keys()
                for key2source in keys2source:
                    print('BINARY: ', key2source)
                    print(response4create2programwithbinary ['CODE4BINARY'] [key2source] [1])
                    # BINARY: ...//__pycache__//hpu2image4xi.cpython-33.pyc
                    # b'l\x0c\r\n'    
            except:
                print('(Step 3Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4create2programwithbinary : ', response4create2programwithbinary)
        else:
            pass                                                                                                    # NOT IN FOCUS
                      
        print('FOCUS 08')          
        if KB4Focus['add2programwithbinary4hpu'] == 'NACK4XI': 
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - ADD BINARY INTO PROGRAM OBJECT WITH FUNCTION                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 3A2/700) OF HPU2PROGRAM4XI5TEST - TRYING TO ADD BINARY INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())        
            try:
                task4add2program = {}
                task4add2program ['CODE4BINARY'] = {}
                # NOT OK - EXISTS
                task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu2image4xi.cpython-33.pyc'] = {}
                task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu2image4xi.cpython-33.pyc'] [1] = b'l\x0c\r\n'
                task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu2image4xi.cpython-33.pyc'] [2] = b'l\x0c\z\n' 
                task4add2program ['SIZE4BINARY'] = {}
                task4add2program ['SIZE4BINARY'] [folder2lib4hpu + '__pycache__//hpu2image4xi.cpython-33.pyc'] = len(task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu2image4xi.cpython-33.pyc'])
                         
                # OK
                task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'] = {}
                task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'] [1] = b'l\x0c\r\n'
                task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'] [2] = b'l\x0c\z\n' 
                task4add2program ['SIZE4BINARY'] = {}
                task4add2program ['SIZE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'] = len(task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'])
                
                response4add2programwithbinary = add2programwithbinary4hpu(task4add2program)
                print('(Step 3A3/700) OF HPU2PROGRAM4XI5TEST - ADDED BINARY INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())
            except:
                print('(Step 3Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4add2programwithbinary: ', response4add2programwithbinary)
            try:                                                                                          
                keys2response = response4add2programwithbinary.keys()
                print('COUNT2REFERENCE:', response4add2programwithbinary ['COUNT2REFERENCE'])   
                print('COUNT4BINARY:', response4add2programwithbinary ['COUNT4BINARY'])
                print('DIRECTORY4BINARY:', response4add2programwithbinary ['DIRECTORY4BINARY']) 
                print('FUNCTION2CALLBACK:', response4add2programwithbinary ['FUNCTION2CALLBACK'])   
                print('LANGUAGE4BINARY:', response4add2programwithbinary ['LANGUAGE4BINARY'])
                print('SIZE4BINARY:', response4add2programwithbinary ['SIZE4BINARY'])                
                # 
                keys2source = response4add2programwithbinary['CODE4BINARY'].keys()
                for key2source in keys2source:
                    print('BINARY: ', key2source)
                    print(response4add2programwithbinary ['CODE4BINARY'] [key2source] [1])
                    # 
                    # COUNT2REFERENCE: 1
                    # COUNT4BINARY: 2
                    # DIRECTORY4BINARY: ...//__pycache__//
                    # FUNCTION2CALLBACK: <function trace2program4hpu at 0x0000000003F96AC8>
                    # LANGUAGE4BINARY: Python
                    # SIZE4BINARY: {'...//__pycache__//hpu2image4xi.cpython-33.pyc': 1006, '...//__pycache__//hpu3image4xi.cpython-33.pyc': 2}
                    # BINARY:  ...//__pycache__//hpu2image4xi.cpython-33.pyc
                    # b'l\x0c\r\n'
                    # BINARY:  ...//__pycache__//hpu3image4xi.cpython-33.pyc
                    # b'l\x0c\r\n'                       
            except:
                print('(Step 3Z3/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4add2programwithbinary : ', response4add2programwithbinary)
        else:
            pass                                                                                                    # NOT IN FOCUS
        print('FOCUS 09')            
        if KB4Focus['delete2programwithbinary4hpu'] == 'NACK4XI':      
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - DELETE BINARY INSIDE PROGRAM OBJECT WITH FUNCTION                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 3A3/700) OF HPU2PROGRAM4XI5TEST - TRYING TO DELETE BINARY INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())        
            try:
                task4delete2program = {}
                task4delete2program ['CODE4BINARY'] = {}
                task4delete2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'] = 'Yes'
                task4delete2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//dummy3image4xi.cpython-33.pyc'] = 'Yes'
    
                task4delete2program ['SIZE4BINARY'] = {}
                task4delete2program ['SIZE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'] = 'Yes'
                task4delete2program ['SIZE4BINARY'] [folder2lib4hpu + '__pycache__//dummy3image4xi.cpython-33.pyc'] = 'Yes'
                
                response4delete2programwithbinary = delete2programwithbinary4hpu(task4delete2program) 
                print('(Step 3A3/700) OF HPU2PROGRAM4XI5TEST - DELETED BINARY INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())
            except:
                print('(Step 3Z3/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO DELETE BINARY INSIDE PROGRAM OBJECT WITH FUNCTION *** ', time4xi()) 
            try:                                                                                          
                keys2response = response4delete2programwithbinary.keys()
                print('COUNT2REFERENCE:', response4delete2programwithbinary ['COUNT2REFERENCE'])   
                print('COUNT4BINARY:', response4delete2programwithbinary ['COUNT4BINARY'])
                print('DIRECTORY4BINARY:', response4delete2programwithbinary ['DIRECTORY4BINARY']) 
                print('FUNCTION2CALLBACK:', response4delete2programwithbinary ['FUNCTION2CALLBACK'])   
                print('LANGUAGE4BINARY:', response4delete2programwithbinary ['LANGUAGE4BINARY'])
                print('SIZE4BINARY:', response4delete2programwithbinary ['SIZE4BINARY'])                
                # 
                keys2source = response4delete2programwithbinary['CODE4BINARY'].keys()
                for key2source in keys2source:
                    print('BINARY: ', key2source)
                    print(response4delete2programwithbinary ['CODE4BINARY'] [key2source] [1])
                # COUNT2REFERENCE: 1
                # COUNT4BINARY: 1
                # DIRECTORY4BINARY: ...//__pycache__//
                # FUNCTION2CALLBACK: <function trace2program4hpu at 0x0000000003B46AC8>
                # LANGUAGE4BINARY: Python
                # SIZE4BINARY: {'...//__pycache__//hpu2image4xi.cpython-33.pyc': 1006}
                # BINARY:  ... //__pycache__//hpu2image4xi.cpython-33.pyc                       
            except:
                print('(Step 3Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4delete2programwithbinary : ', response4delete2programwithbinary)         
        else:
            pass                                                                                                    # NOT IN FOCUS
        print('FOCUS 10')           
        if KB4Focus['get2programinfo4hpu'] == 'NACK4XI':                  
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - GET SOME PROGRAM BINARY INFO WITH FUNCTION                
            # ---------------------------------------------------------------------------------------------    
            print('(Step 3B1/700) OF HPU2PROGRAM4XI5TEST - TRYING TO GET SOME PROGRAM BINARY INFO FOR HPU ', time4xi())     
            task4getinfo2program = {}
            task4getinfo2program ['FUNCTION2CALLBACK'] = 'Yes'
            task4getinfo2program ['COUNT4BINARY'] = 'Yes'
            task4getinfo2program ['DIRECTORY4BINARY'] = 'Yes'
            task4getinfo2program ['CODE4BINARY'] = 'Yes'
            task4getinfo2program ['SIZE4BINARY'] = 'Yes'
            task4getinfo2program ['LANGUAGE4BINARY'] = 'Yes'
            task4getinfo2program ['COUNT2REFERENCE'] = 'Yes'
            task4getinfo2program ['CODE4BINARY'] = 'Yes'
            try:
                response4programinfo2hpu = get2programinfo4hpu(task4getinfo2program) 
                print('(Step 3B2/700) OF HPU2PROGRAM4XI5TEST - GOT SOME PROGRAM BINARY INFO FOR HPU ', time4xi())
            except:
                print('(Step 3Z3/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO GET SOME PROGRAM BINARY INFO FOR HPU', time4xi())                  
            try:                                                                                          
                keys2response = response4programinfo2hpu.keys()
                print('COUNT2REFERENCE:', response4programinfo2hpu ['COUNT2REFERENCE'])   
                print('COUNT4BINARY:', response4programinfo2hpu ['COUNT4BINARY'])
                print('DIRECTORY4BINARY:', response4programinfo2hpu ['DIRECTORY4BINARY']) 
                print('FUNCTION2CALLBACK:', response4programinfo2hpu ['FUNCTION2CALLBACK'])   
                print('LANGUAGE4BINARY:', response4programinfo2hpu ['LANGUAGE4BINARY'])
                print('SIZE4BINARY:', response4programinfo2hpu ['SIZE4BINARY'])                
                # 
                keys2source = response4programinfo2hpu['CODE4BINARY'].keys()
                for key2source in keys2source:
                    print('BINARY: ', key2source)
                    print(response4programinfo2hpu ['CODE4BINARY'] [key2source] [1])
                    # COUNT2REFERENCE: 1
                    # COUNT4BINARY: 1
                    # DIRECTORY4BINARY: ...//__pycache__//
                    # FUNCTION2CALLBACK: <function trace2program4hpu at 0x0000000004144AC8>
                    # LANGUAGE4BINARY: Python
                    # SIZE4BINARY: {'...//__pycache__//hpu2image4xi.cpython-33.pyc': 1006}
                    # BINARY:  ...//__pycache__//hpu2image4xi.cpython-33.pyc
                    # b'l\x0c\r\n'                       
            except:
                print('(Step 3Z4/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4programinfo2hpu : ', response4programinfo2hpu)
        else:
            pass                                                                                                    # NOT IN FOCUS
        
        print('FOCUS 11')           
        if KB4Focus['get2programinfo4hpu'] == 'NACK4XI': 
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - GET ALL PROGRAM BINARY INFO WITH FUNCTION                
            # ---------------------------------------------------------------------------------------------           
            print('(Step 3C1/700) OF HPU2PROGRAM4XI5TEST - TRYING TO GET ALL PROGRAM BINARY INFO FOR HPU ', time4xi())      
            try:
                response4getinfo2program = get2programinfo4hpu()
                print('(Step 3C2/700) OF HPU2PROGRAM4XI5TEST - GOT ALL PROGRAM BINARY INFO FOR HPU ', time4xi())   
              
            except:
                print('(Step 3Z3/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO GET ALL PROGRAM BINARY INFO FOR HPU ***', time4xi()) 
            try:                                                                                         
                keys2response = response4getinfo2program.keys()
                for key2response in sorted(keys2response):
                    print(key2response)
                    # ACK2RETURN
                    # BUFFER
                    # CODE2ERROR
                    # CODE4BINARY
                    # COMMANDQUEUE
                    # CONTEXT
                    # COUNT2REFERENCE
                    # COUNT4BINARY
                    # DATA2CALLBACK
                    # DEVICE
                    # DIRECTORY4BINARY
                    # EVENT
                    # FUNCTION2CALLBACK
                    # LANGUAGE4BINARY
                    # NACK2RETURN
                    # PIPE
                    # PLATFORM
                    # QUEUE
                    # SIZE4BINARY
                   
            except:
                print('(Step 3Z3/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4getinfo2program ', response4getinfo2program)
        else:
            pass                                                                                                    # NOT IN FOCUS
        
        print('FOCUS 12')           
        if KB4Focus['set2programwithsource4hpu'] == 'NACK4XI':                     
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - SET PROGRAM SOURCE WITH FUNCTION - ALL ATTRIBUTES                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 4A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET PROGRAM SOURCE WITH FUNCTION ', time4xi())    

            # ---------------------------------------------------------------------------------------------
            # (1) GET PLATFORM IDs TO SET CONTEXT
            # ---------------------------------------------------------------------------------------------    
            print('(Step 4B/700) OF HPU2PROGRAM4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
            platform2xi = {}
            try:
                platform2xi = get2platformids4xi()
                print('(Step 4B/33) OF HPU2PROGRAM4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1} 
                 
            except:
                print('(Step 4Z/33) OF HPU2PROGRAM4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
        
            # ---------------------------------------------------------------------------------------------
            # (2) INITIALIZE DEVICE                       
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2A/33) OF HPU2PROGRAM4XI5TEST - TRYING TO INITIALIZE DEVICE4HPU ', time4xi())   
            try:
                device2hpu = init2hpu4xi()                                                                                
                print('(Step 2B/33) OF HPU2PROGRAM4XI5TEST - INITIALIZED DEVICE4HPU TO: ', device2hpu)        
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                
            except:
                print('(Step 2Z/33) OF HPU2PROGRAM4XI5TEST *** FAILED TO INITIALIZE DEVICE4HPU', time4xi()) 
                    
                
            # ---------------------------------------------------------------------------------------------
            # (3) CREATE CONTEXT                  
            # ---------------------------------------------------------------------------------------------    
            print('(Step 3A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO CREATE CONTEXT4HPU ', time4xi())    
            try:
                context2hpu = create2context4hpu()                                                                            
                print('(Step 3B/700) OF HPU2PROGRAM4XI5TEST - CREATED CONTEXT4HPU: ', context2hpu)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
            except:
                print('(Step 3Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO CREATE CONTEXT4HPU', time4xi()) 
             
        
                  
            # ---------------------------------------------------------------------------------------------
            # (4) INITIALIZE TASK DICTIONARY                         
            # ---------------------------------------------------------------------------------------------            
            task4set2programws = {}
        
            
            # ---------------------------------------------------------------------------------------------
            # (5) DEFINE CONTEXT - REQUIRED                           
            # ---------------------------------------------------------------------------------------------         
            task4set2programws  ['CONTEXT'] = context2hpu  
         
            
            # ---------------------------------------------------------------------------------------------
            # (6) DEFINE DEVICE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            task4set2programws  ['DEVICE'] = device2hpu  
        
    
            # ---------------------------------------------------------------------------------------------
            # (8) DEFINE ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4set2programws  ['CODE2ERROR'] = 0 
        
            
            # ---------------------------------------------------------------------------------------------
            # (9) SET QUEUE - EXTRA                            
            # ---------------------------------------------------------------------------------------------         
            task4set2programws ['QUEUE'] = None
            print('(Step 9A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET QUEUE FOR PROGRAM4HPU ', time4xi())   
            try:                               
                task4set2programws ['QUEUE'] = Queue4Xi()                                                                                                                    
                print('(Step 9B/700) OF HPU2PROGRAM4XI5TEST - QUEUE OF PROGRAM4HPU: ', task4set2programws ['QUEUE'])                           
                # 
                
            except:
                print('(Step 9Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET QUEUE FOR PROGRAM4HPU ', time4xi())  
                         
            
                    
            # ---------------------------------------------------------------------------------------------
            # (11) SET COUNT4SOURCE              
            # ---------------------------------------------------------------------------------------------         
            print('(Step 11A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET COUNT4SOURCE FOR PROGRAM4HPU ', time4xi())    
            try:                               
                task4set2programws ['COUNT4SOURCE'] = int(len(kb2fetch4hpu)/2)                                                                                                               
                print('(Step 11B/700) OF HPU2PROGRAM4XI5TEST - COUNT4SOURCE OF PROGRAM4HPU: ', task4set2programws ['COUNT4SOURCE'])                           
                # 1
                
            except:
                print('(Step 11Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET COUNT4SOURCE FOR PROGRAM4HPU ', time4xi())  
                
            
            # ---------------------------------------------------------------------------------------------
            # (12) SET DIRECTORY4SOURCE                       
            # ---------------------------------------------------------------------------------------------         
            print('(Step 12A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET DIRECTORY4SOURCE FOR PROGRAM4HPU ', time4xi())    
            try: 
                     
                task4set2programws ['DIRECTORY4SOURCE'] = folder2lib4hpu                                                                                                          
                print('(Step 12B/700) OF HPU2PROGRAM4XI5TEST - DIRECTORY4SOURCE OF PROGRAM4HPU: ', task4set2programws ['DIRECTORY4SOURCE'])                            
                # folder2lib4hpu
                
            except:
                print('(Step 12Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET DIRECTORY4SOURCE FOR PROGRAM4HPU ', time4xi())  
                    
            
            # ---------------------------------------------------------------------------------------------
            # (14) SET LANGUAGE4SOURCE                       
            # ---------------------------------------------------------------------------------------------         
            task4set2programws ['LANGUAGE4SOURCE'] = None
            print('(Step 14A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET LANGUAGE4SOURCE FOR PROGRAM4HPU ', time4xi())    
            try:                               
                task4set2programws ['LANGUAGE4SOURCE'] = "Python"                                                                                                                   
                print('(Step 14B/700) OF HPU2PROGRAM4XI5TEST - LANGUAGE4SOURCE OF PROGRAM4HPU: ', task4set2programws ['LANGUAGE4SOURCE'])                           
                # Python
                
            except:
                print('(Step 14Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET LANGUAGE4SOURCE FOR PROGRAM4HPU ', time4xi())  
                
            
            
            # ---------------------------------------------------------------------------------------------
            # (15) SET CODE4SOURCE                       
            # ---------------------------------------------------------------------------------------------         
            task4set2programws ['CODE4SOURCE'] = None
            print('(Step 15A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET SOURCE OF TASK FOR PROGRAM4HPU  ', time4xi())     
            try: 
                source4hpu = {}
                key2source4hpu = folder2lib4hpu + 'hpu2image4xi5test.py'
                code2source4hpu = {}
                code2source4hpu [1] = '#<profile4xi profile = "11" />\n'
                code2source4hpu [2] = '#<program4xi program = "hpu2image4xi5test.py">\n'
                
                source4hpu [key2source4hpu] = code2source4hpu
                                          
                task4set2programws ['CODE4SOURCE'] = source4hpu                                                                                                              
                print('(Step 15B/700) OF HPU2PROGRAM4XI5TEST - SET SOURCE OF TASK FOR PROGRAM4HPU TO: ', task4set2programws ['CODE4SOURCE'])                           
                # {folder2lib4hpu + 'hpu2image4xi5test.py': {1: '#<profile4xi profile = "11" />\n', 2: '#<program4xi program = "hpu2image4xi5test.py">\n'}}
    
            except:
                print('(Step 15Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET SOURCE OF TASK FOR PROGRAM4HPU  ', time4xi()) 
            
            # ---------------------------------------------------------------------------------------------
            # (16) SET SIZE4SOURCE             
            # ---------------------------------------------------------------------------------------------         
            task4set2programws ['SIZE4SOURCE'] = 0
            print('(Step 16A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET SOURCE OF TASK FOR PROGRAM4HPU  ', time4xi())     
            try: 
                task4set2programws ['SIZE4SOURCE'] = len(source4hpu)                                                                                                              
                print('(Step 16B/700) OF HPU2PROGRAM4XI5TEST - SET SIZE OF SOURCE OF TASK FOR PROGRAM4HPU TO: ', task4set2programws ['SIZE4SOURCE'])                           
                # 
    
            except:
                print('(Step 16Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET SOURCE OF TASK FOR PROGRAM4HPU  ', time4xi()) 
                            
                                
            # ---------------------------------------------------------------------------------------------
            # (17) SET PROGRAM - FINALLY!                           
            # ---------------------------------------------------------------------------------------------          
            response4set2program = {} 
            print('(Step 17F/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET PROGRAM WITH SOURCE: ', set2programwithsource4hpu)   
            # <function set2programwithsource4hpu at 0x0000000003837948>
            try:                               
                response4set2pws = set2programwithsource4hpu(task4set2programws)
                print('(Step 17G/700) OF HPU2PROGRAM4XI5TEST - SET PROGRAM SOURCE WITH SOURCE: ', set2programwithsource4hpu)                                                                                                           
            except:
                print('(Step 17Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET PROGRAM SOURCE WITH SOURCE: ', set2programwithsource4hpu)  
            try:                                                                                          
                keys2response = response4set2pws.keys()
                print('COUNT2REFERENCE:', response4set2pws ['COUNT2REFERENCE'])   
                print('COUNT4SOURCE:', response4set2pws ['COUNT4SOURCE'])
                print('DIRECTORY4SOURCE:', response4set2pws ['DIRECTORY4SOURCE']) 
                print('FUNCTION2CALLBACK:', response4set2pws ['FUNCTION2CALLBACK'])   
                print('LANGUAGE4SOURCE:', response4set2pws ['LANGUAGE4SOURCE'])
                print('SIZE4SOURCE:', response4set2pws ['SIZE4SOURCE'])                

                keys2source = response4set2pws['CODE4SOURCE'].keys()
                for key2source in keys2source:
                    print('SOURCE: ', key2source)
                    print(response4set2pws ['CODE4SOURCE'] [key2source] [1])
                    #
                    # COUNT2REFERENCE: 1
                    # COUNT4SOURCE: 1
                    # DIRECTORY4SOURCE: OK
                    # FUNCTION2CALLBACK: <function trace2program4hpu at 0x0000000003A28B48>
                    # LANGUAGE4SOURCE: Python
                    # SIZE4SOURCE: 1
                    # SOURCE:  ... hpu2image4xi5test.py
                    # #<profile4xi profile = "11" />                  
            except:
                print('(Step 3Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4set2pws : ', response4set2pws)                                               
        else:
            pass                                                                                                    # NOT IN FOCUS
          
        print('FOCUS 14')                 
        if KB4Focus['set2programwithbinary4hpu'] == 'NACK4XI':                     
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - SET PROGRAM BINARY  BINARY FUNCTION - ALL ATTRIBUTES                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 24A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET PROGRAM BINARY WITH FUNCTION ', time4xi())    
            
            # ---------------------------------------------------------------------------------------------
            # (21) GET PLATFORM IDs TO SET CONTEXT
            # ---------------------------------------------------------------------------------------------    
            print('(Step 21A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
            platform2xi = {}
            try:
                platform2xi = get2platformids4xi()
                print('(Step 21B/33) OF HPU2PROGRAM4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                 
            except:
                print('(Step 21Z/33) OF HPU2PROGRAM4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
        
            # ---------------------------------------------------------------------------------------------
            # (22) INITIALIZE DEVICE                       
            # ---------------------------------------------------------------------------------------------    
            print('(Step 22A/33) OF HPU2PROGRAM4XI5TEST - TRYING TO INITIALIZE DEVICE4HPU ', time4xi())   
            try:
                device2hpu = init2hpu4xi()                                                                                
                print('(Step 22B/33) OF HPU2PROGRAM4XI5TEST - INITIALIZED DEVICE4HPU TO: ', device2hpu)        
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                
            except:
                print('(Step 22Z/33) OF HPU2PROGRAM4XI5TEST *** FAILED TO INITIALIZE DEVICE4HPU', time4xi()) 
                    
                
            # ---------------------------------------------------------------------------------------------
            # (23) CREATE CONTEXT                  
            # ---------------------------------------------------------------------------------------------    
            print('(Step 23A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO CREATE CONTEXT4HPU ', time4xi())    
            try:
                context2hpu = create2context4hpu()                                                                            
                print('(Step 23B/700) OF HPU2PROGRAM4XI5TEST - CREATED CONTEXT4HPU: ', context2hpu)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
                
            except:
                print('(Step 23Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO CREATE CONTEXT4HPU', time4xi()) 
             
        
                  
            # ---------------------------------------------------------------------------------------------
            # (24) INITIALIZE TASK DICTIONARY                         
            # ---------------------------------------------------------------------------------------------            
            task4set2programwithbinary = {}
        
            
            # ---------------------------------------------------------------------------------------------
            # (25) DEFINE CONTEXT - REQUIRED                           
            # ---------------------------------------------------------------------------------------------         
            task4set2programwithbinary  ['CONTEXT'] = context2hpu  
         
            
            # ---------------------------------------------------------------------------------------------
            # (26) DEFINE DEVICE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            task4set2programwithbinary  ['DEVICE'] = device2hpu  
        
    
            # ---------------------------------------------------------------------------------------------
            # (28) DEFINE ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4set2programwithbinary  ['CODE2ERROR'] = 0 
        
            
            # ---------------------------------------------------------------------------------------------
            # (29) SET QUEUE - EXTRA                            
            # ---------------------------------------------------------------------------------------------         
            task4set2programwithbinary ['QUEUE'] = None
            print('(Step 29A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET QUEUE FOR PROGRAM4HPU ', time4xi())   
            try:                               
                task4set2programwithbinary ['QUEUE'] = Queue4Xi()                                                                                                                    
                print('(Step 29B/700) OF HPU2PROGRAM4XI5TEST - QUEUE OF PROGRAM4HPU: ', task4set2programwithbinary ['QUEUE'])                           
                # <queue4xi.Queue4Xi object at 0x0000000003F095F8>
                
            except:
                print('(Step 29Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET QUEUE FOR PROGRAM4HPU ', time4xi())  
                         
            
                    
            # ---------------------------------------------------------------------------------------------
            # (31) SET COUNT4BINARY              
            # ---------------------------------------------------------------------------------------------         
            print('(Step 31A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET COUNT4BINARY FOR PROGRAM4HPU ', time4xi())    
            try:                               
                task4set2programwithbinary ['COUNT4BINARY'] = int(len(kb2fetch4hpu)/2)                                                                                                               
                print('(Step 31B/700) OF HPU2PROGRAM4XI5TEST - COUNT4BINARY OF PROGRAM4HPU: ', task4set2programwithbinary ['COUNT4BINARY'])                           
                # 1
                
            except:
                print('(Step 31Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET COUNT4BINARY FOR PROGRAM4HPU ', time4xi())  
                
            
            # ---------------------------------------------------------------------------------------------
            # (32) SET DIRECTORY4BINARY                       
            # ---------------------------------------------------------------------------------------------         
            print('(Step 32A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET DIRECTORY4BINARY FOR PROGRAM4HPU ', time4xi())    
            try: 
                task4set2programwithbinary ['DIRECTORY4BINARY'] = folder2lib4hpu + "__pycache__//"                                                                                                           
                print('(Step 32B/700) OF HPU2PROGRAM4XI5TEST - DIRECTORY4BINARY OF PROGRAM4HPU: ', task4set2programwithbinary ['DIRECTORY4BINARY'])                           
                # ... //__pycache__//
                
            except:
                print('(Step 212Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET DIRECTORY4BINARY FOR PROGRAM4HPU ', time4xi())  
                    
            
            # ---------------------------------------------------------------------------------------------
            # (34) SET LANGUAGE4BINARY                       
            # ---------------------------------------------------------------------------------------------         
            task4set2programwithbinary ['LANGUAGE4BINARY'] = None
            print('(Step 34A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET LANGUAGE4BINARY FOR PROGRAM4HPU ', time4xi())    
            try:                               
                task4set2programwithbinary ['LANGUAGE4BINARY'] = "Python"                                                                                                                   
                print('(Step 34B/700) OF HPU2PROGRAM4XI5TEST - LANGUAGE4BINARY OF PROGRAM4HPU: ', task4set2programwithbinary ['LANGUAGE4BINARY'])                           
                # Python
                
            except:
                print('(Step 34Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET LANGUAGE4BINARY FOR PROGRAM4HPU ', time4xi())  
                
            
            
            # ---------------------------------------------------------------------------------------------
            # (35) SET CODE4BINARY                       
            # ---------------------------------------------------------------------------------------------         
            task4set2programwithbinary ['CODE4BINARY'] = None
            print('(Step 35A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET BINARY OF TASK FOR PROGRAM4HPU  ', time4xi())     
            try: 
                binary4hpu = {}
                key2binary4hpu = folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'
                code2binary4hpu = {}
                code2binary4hpu [1] = b'l\x0c\r\n'
                code2binary4hpu [2] = b'\x00Z\n'
                
                binary4hpu [key2binary4hpu] = code2binary4hpu
                                          
                task4set2programwithbinary ['CODE4BINARY'] = binary4hpu                                                                                                              
                print('(Step 35B/700) OF HPU2PROGRAM4XI5TEST - SET BINARY OF TASK FOR PROGRAM4HPU TO: ', task4set2programwithbinary ['CODE4BINARY'])                           
                # {folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc': {1: b'l\x0c\r\n', 2: b'\x00Z\n'}}
    
            except:
                print('(Step 35Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET BINARY OF TASK FOR PROGRAM4HPU  ', time4xi()) 
            
            # ---------------------------------------------------------------------------------------------
            # (36) SET SIZE4BINARY                       
            # ---------------------------------------------------------------------------------------------         
            task4set2programwithbinary ['SIZE4BINARY'] = 1
            print('(Step 36A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET BINARY OF TASK FOR PROGRAM4HPU  ', time4xi())     
            try: 
                task4set2programwithbinary ['SIZE4BINARY'] = len(binary4hpu)                                                                                                              
                print('(Step 36B/700) OF HPU2PROGRAM4XI5TEST - SET SIZE OF BINARY OF TASK FOR PROGRAM4HPU TO: ', task4set2programwithbinary ['SIZE4BINARY'])                           
                # 1
    
            except:
                print('(Step 36Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET BINARY OF TASK FOR PROGRAM4HPU  ', time4xi()) 
                            
                                
            # ---------------------------------------------------------------------------------------------
            # (37) SET PROGRAM - FINALLY!                           
            # ---------------------------------------------------------------------------------------------          
            response4set2program = {} 
            print('(Step 37F/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET PROGRAM BINARY WITH FUNCTION: ', set2programwithbinary4hpu)   
            # 
            try:                               
                response4set2pwb = set2programwithbinary4hpu(task4set2programwithbinary)
                print('(Step 37G/700) OF HPU2PROGRAM4XI5TEST - SET PROGRAM BINARY WITH FUNCTION: ', set2programwithbinary4hpu)
                # OK   
            except:
                print('(Step 37Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET PROGRAM BINARY WITH FUNCTION: ', set2programwithbinary4hpu) 
        

                                                                                                                # NOT IN FOCUS
        print('FOCUS 15')   
        if KB4Focus['release2program4hpu'] == 'NACK4XI': 
            # ---------------------------------------------------------------------------------------------
            # (18) REFERENCE COUNT FOR PROCESSING UNIT RELEASED BY DECREMENTING COUNT WITH 1             
            # ---------------------------------------------------------------------------------------------    
            task4release2program  = {} 
            task4release2program  ['COUNT2REFERENCE'] = 1 
            response4release2program = {}
            
            print('(Step 18A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO RELEASE PROGRAM OF HPU DEVICE ', time4xi())    
            # 
            try:                               
                response4release2program = release2program4hpu(task4release2program)
                print('(Step 18B/700) OF HPU2PROGRAM4XI5TEST - RELEASED PROGRAM OF HPU DEVICE ', time4xi()) 
            except:
                print('(Step 18Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO RELEASE PROGRAM OF HPU DEVICE ', time4xi())                                                                                                  
            try:
                print('(Step 18C/700) OF HPU2PROGRAM4XI5TEST COUNT2REFERENCE: ', response4release2program ['COUNT2REFERENCE'])
                # 0
            except:
                print('(Step 18Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4RELEASE2PROGRAM ', response4release2program)  
            
        
            print('(Step 18D/700) OF HPU2PROGRAM4XI5TEST - TRYING TO GET COUNT2REFERENCE OF HPU DEVICE ', time4xi())     
            #
            task4getinfo2program = {}
            task4getinfo2program ['COUNT2REFERENCE'] = 'Yes' 
            try:                               
                response4getinfo2program = get2programinfo4hpu (task4getinfo2program)
                print('(Step 18E/700) OF HPU2PROGRAM4XI5TEST - GOT COUNT2REFERENCE OF HPU DEVICE ', time4xi())
            except:
                print('(Step 18Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO GET SELECTED PROGRAM INFO OF HPU DEVICE ', time4xi())
            try:                                                                                                      
                print('(Step 18F/700) OF HPU2PROGRAM4XI5TEST - COUNT2REFERENCE: ', response4getinfo2program['COUNT2REFERENCE'] )
                # 0
            except:
                print('(Step 18Z3/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4GETINFO2PROGRAM', response4getinfo2program)  
        else:
            pass

        print('FOCUS 16')
        if KB4Focus['retain2program4hpu'] == 'NACK4XI':                                                                                                                 # NOT IN FOCUS                                                   
            task4retain2program  = {} 
            task4retain2program  ['COUNT2REFERENCE'] = 1 
            response4retain2program = {}
            
            print('(Step 19A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO RETAIN PROGRAM OF HPU DEVICE ', time4xi())    
            # 
            try:                               
                response4retain2program = retain2program4hpu(task4retain2program)
                print('(Step 19B/700) OF HPU2PROGRAM4XI5TEST - RETAINED PROGRAM OF HPU DEVICE ', time4xi()) 
            except:
                print('(Step 19Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO RETAIN PROGRAM OF HPU DEVICE ', time4xi())                                                                                                  
            try:
                print('(Step 19C/700) OF HPU2PROGRAM4XI5TEST COUNT2REFERENCE: ', response4retain2program ['COUNT2REFERENCE'])
                # 2
            except:
                print('(Step 19Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4RETAIN2PROGRAM ', response4retain2program)  
            
        
            print('(Step 19D/700) OF HPU2PROGRAM4XI5TEST - TRYING TO GET COUNT2REFERENCE OF HPU DEVICE ', time4xi())     
            #
            task4getinfo2program = {}
            task4getinfo2program ['COUNT2REFERENCE'] = 'Yes' 
            try:                               
                response4getinfo2program = get2programinfo4hpu (task4getinfo2program)
                print('(Step 19E/700) OF HPU2PROGRAM4XI5TEST - GOT COUNT2REFERENCE OF HPU DEVICE ', time4xi())
            except:
                print('(Step 19Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO GET SELECTED PROGRAM INFO OF HPU DEVICE ', time4xi())
            try:                                                                                                      
                print('(Step 19F/700) OF HPU2PROGRAM4XI5TEST - COUNT2REFERENCE: ', response4getinfo2program['COUNT2REFERENCE'] )
                # 2
            except:
                print('(Step 19Z3/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4GETINFO2PROGRAM', response4getinfo2program)  
        else:
            pass
                                                                                                                # NOT IN FOCUS
                      
        print('FOCUS 17')        
        if KB4Focus['set2programcallback4hpu'] == 'NACK4XI': 
            # ---------------------------------------------------------------------------------------------
            # (20) SET PROGRAM CALLBACKS            
            # ---------------------------------------------------------------------------------------------    
            
            print('(Step 20A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET PROGRAM CALLBACK OF HPU ', time4xi())     
            # 23:59:58 11/16/11 Pacific Standard Time
            try:                               
                response4setcallback2program = set2programcallback4hpu()                                                                                                 
                print('(Step 20B/700) OF HPU2PROGRAM4XI5TEST - SET PROGRAM CALLBACK OF HPU TO: ', response4setcallback2program)   
                # <function trace2program4hpu at 0x00000000038E02C8>
            except:
                print('(Step 20Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET PROGRAM CALLBACK OF HPU ', time4xi())  
        else:
            pass                                                                                                    # NOT IN FOCUS
        print('FOCUS 18')       
        if KB4Focus['trace2program4hpu'] == 'NACK4XI':                                                                                                       
            # ---------------------------------------------------------------------------------------------
            # PHASE I: TRACE FUNCTION TESTS                    
            # ---------------------------------------------------------------------------------------------    
            print('(Step 98A/25) OF HPU2PROGRAM4XI5TEST - TRYING TO TRACE HPU: ', time4xi())      
            trace2hpu = None
            try:
                trace2hpu = trace2program4hpu() 
                print('(Step 98B/25) OF HPU2PROGRAM4XI5TEST - TRACE2HPU: ', trace2hpu)  
                # {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4hpu-failed {}; time: 04:40:23 11/16/11 Pacific Standard Time}', 'CLASS': 'trace2program4hpu', 'METHOD': 'trace2program4hpu'}
        
            except:
                print('(Step 98Z1/25) OF HPU2PROGRAM4XI5TEST *** FAILED TO TRACE HPU: ', trace2hpu)     
            
        print('FOCUS 19')      
        if KB4Focus['build2program4hpu'] == 'NACK4XI':                                                                                                             
            task4build2program  = {}
            task4build2program  ['PROGRAM'] = folder2lib4hpu + 'hpu2sampler4xi.py'
            task4build2program  ['OPTIONS'] = {}
            task4build2program  ['OPTIONS'] ['MATH']          = 'SINGLE-PRECISION-CONSTANT'
            task4build2program  ['OPTIONS'] ['OPTIMIZATION']  = 'DISABLE'
            task4build2program  ['OPTIONS'] ['VERSION']       = 'CL1.1'
            task4build2program  ['OPTIONS'] ['WARNINGS']      = 'INHIBIT'
            print('(Step 99A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO BUILD PROGRAM OF HPU DEVICE ', time4xi())    
            # 
            try:                               
                response4build2program = build2program4hpu(task4build2program)
                print('(Step 99B/700) OF HPU2PROGRAM4XI5TEST - BUILT PROGRAM OF HPU DEVICE ', time4xi())
            except:
                print('(Step 99Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO BUILD PROGRAM OF HPU DEVICE ', time4xi())  
            try:                                                                                                                 
                keys2response = response4build2program.keys()
                for key2response in sorted(keys2response):
                    print(key2response, ' : ', response4build2program[key2response])
                    # ACK2RETURN  :   11A1-12A1-
                    # NACK2RETURN  :   13Z1-14Z1-
                    # OPTIONS  :  {'VERSION': 'CL1.1', 'OPTIMIZATION': 'DISABLE', 'MATH': 'SINGLE-PRECISION-CONSTANT', 'WARNINGS': 'INHIBIT'}
                    # PROGRAM  :  folder2lib4hpu + 'hpu2sampler4xi.py'
                
            except:
                print('(Step 99Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4BUILD2PROGRAM ', response4build2program)      
        else:
            pass                                                                                                    # NOT IN FOCUS
        # ========================================================================================================================
        # CLASS TESTS
        # ========================================================================================================================    
        print('FOCUS 110')       
        if KB4Focus['HPU2Program4Xi'] == 'NACK4XI':                                                                                                                                                                 
            # ---------------------------------------------------------------------------------------------
            # PHASE II: CLASS TESTS                          
            # ---------------------------------------------------------------------------------------------
                     
            print('(Step 110/700) OF HPU2PROGRAM4XI5TEST - STARTING CLASS TESTS', time4xi())        
            #       
            tailor2trace4program(t2xi)                  # <-- tailor trace again - target functions of activated processes might have reset trace ! 
            
            print('(Step 110A/700) OF HPU2PROGRAM4XI5TEST - CREATING PROGRAM4HPU OBJECT ', time4xi())        
            try:
                # ---------------------------------------------------------------------------------------------
                # CREATE WITH OBJECT                  
                # ---------------------------------------------------------------------------------------------        
                programobject2hpu = HPU2Program4Xi()
                print('(Step 110B/700) OF HPU2PROGRAM4XI5TEST - CREATED PROGRAM4HPU OBJECT: ', programobject2hpu)                                  
                # <hpu2program4xi.HPU2Program4Xi object at 0x0000000003F69198>
                
            except:
                print('(Step 110Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO CREATE PROGRAM4HPU OBJECT')
                

            print('FOCUS 121A')      
            if KB4Focus['compile2program'] == 'NACK4XI':                                                                                                                                  
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - COMPILE                          
                # ---------------------------------------------------------------------------------------------
                print('(Step 121A1/700) OF HPU2PROGRAM4XI5TEST - COMPILING PROGRAM FOR HPU', time4xi())      
                try:
                    # ---------------------------------------------------------------------------------------------
                    # COMPILE                        
                    # ---------------------------------------------------------------------------------------------        
                    response4compile = programobject2hpu.compile2program()
                    print('(Step 121A2/700) OF HPU2PROGRAM4XI5TEST - COMPILING PROGRAM FOR HPU', time4xi())                                   
                except:
                    print('(Step 121AZ1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO COMPILE PROGRAM FOR HPU')
                try:
                    keys2response4compile = response4compile.keys()
                    for key2response4compile in keys2response4compile:
                        print('(Step 121A3/700) OF HPU2PROGRAM4XI5TEST - KEY OF RESPONSE4COMPILE: ', key2response4compile)
                        # hpu2sampler4xi5test.py 
                except:
                    print('(Step 121AZ2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4COMPILE:' , response4compile)
                             
                tailor2trace4program(t2xi)                  # <-- tailor trace again - target functions of activated processes might have reset trace ! 
            else:
                pass                                                                                                # NOT IN FOCUS
            
            print('FOCUS 121C')                                                                                                                                                           
            if KB4Focus['link2program'] == 'NACK4XI':
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - LINK                          
                # ---------------------------------------------------------------------------------------------
                print('(Step 121C1/700) OF HPU2PROGRAM4XI5TEST - LINKING PROGRAM FOR HPU', time4xi())      
                try:
                    # ---------------------------------------------------------------------------------------------
                    # LINK                        
                    # ---------------------------------------------------------------------------------------------        
                    response4link = programobject2hpu.link2program()
                    print('(Step 121C2/700) OF HPU2PROGRAM4XI5TEST - COMPILING PROGRAM FOR HPU', time4xi())                                   
                except:
                    print('(Step 121CZ1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO LINK PROGRAM FOR HPU')
                try:
                    keys2response4link = response4link.keys()
                    for key2response4link in keys2response4link:
                        print('(Step 121C3/700) OF HPU2PROGRAM4XI5TEST - KEY OF RESPONSE4LINK: ', key2response4link)
                        # 
                except:
                    print('(Step 121CZ2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4LINK:' , response4link)
            else:
                pass                                                                                                # NOT IN FOCUS
                
            print('FOCUS 122')                      
            if KB4Focus['add2programwithsource'] == 'NACK4XI':        
                # ---------------------------------------------------------------------------------------------
                # PHASE I: CLASS TESTS - ADD SOURCE INTO PROGRAM OBJECT WITH CLASS                          
                # ---------------------------------------------------------------------------------------------    
                print('(Step 122A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO ADD SOURCE INTO PROGRAM OBJECT WITH CLASS ', time4xi())          
                try:
                    task4add2program = {}
                    # 
                    task4add2program ['CODE4SOURCE'] = {}
                    task4add2program ['SIZE4SOURCE'] = {}
                                
                    task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] = {}
                    task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] [1] = '#<profile4xi profile = "33" />\n'
                    task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] [2] = '#<program4xi program = "hpu2buffer4xi.py" />\n'
                    task4add2program ['SIZE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] = len(task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'])
                    # 
                    task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2sampler4xi5test.py'] = {}
                    task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2sampler4xi5test.py'] [1] = '#<profile4xi profile = "33" />\n'
                    task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2sampler4xi5test.py'] [2] = '#<program4xi program = "hpu2sampler4xi5test.py" />\n'
                    
                    task4add2program ['SIZE4SOURCE'] [folder2lib4hpu + 'hpu2sampler4xi5test.py'] = len(task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2sampler4xi5test.py'])            
                    task4add2program ['SIZE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] = len(task4add2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'])            
                    
                    response4add2programwithsource = programobject2hpu.add2programwithsource(task4add2program)
                    print('(Step 122B/700) OF HPU2PROGRAM4XI5TEST - ADDED SOURCE INTO PROGRAM OBJECT WITH CLASS ', time4xi())    
                except:
                    print('(Step 122Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO ADD SOURCE INTO PROGRAM OBJECT WITH CLASS *** ', time4xi())
                try:                                                                                      
                    print('COUNT4SOURCE: ', response4add2programwithsource['COUNT4SOURCE'])
                    print('DIRECTORY4SOURCE: ', response4add2programwithsource['DIRECTORY4SOURCE'])
                    print('LANGUAGE4SOURCE: ', response4add2programwithsource['LANGUAGE4SOURCE'])
                    print('SIZE4SOURCE: ', response4add2programwithsource['SIZE4SOURCE'])
                    keys2source = response4add2programwithsource['CODE4SOURCE'].keys()
                    for key2source in keys2source:
                        print('SOURCE: ', key2source)
                        print(response4add2programwithsource ['CODE4SOURCE'] [key2source] [1])
                    # COUNT4SOURCE:  2
                    # DIRECTORY4SOURCE:  OK
                    # LANGUAGE4SOURCE:  Python
                    # SIZE4SOURCE:  {' ... //hpu2buffer4xi.py': 2, '... hpu2sampler4xi5test.py': 1337}
                    # SOURCE:  ... //hpu2buffer4xi.py
                    # #<profile4xi profile = "33" />
                    # 
                    # SOURCE:  ... hpu2sampler4xi5test.py
                    # #<profile4xi profile = "11" />                              
                except:
                    print('(Step 1222Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4ADD2PROGRAMWITHSOURCE: ', response4add2programwithsource)  
            else:
                pass                                                                                                # NOT IN FOCUS
                
            print('FOCUS 124')          
            if KB4Focus['delete2programwithsource'] == 'NACK4XI':    
                # ---------------------------------------------------------------------------------------------
                # PHASE I: CLASS TESTS - DELETE SOURCE FROM PROGRAM OBJECT WITH CLASS                          
                # ---------------------------------------------------------------------------------------------    
                print('(Step 124A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO DELETE SOURCE IN PROGRAM OBJECT WITH CLASS ', time4xi())        
                try:
                    task4delete2program = {}
                    task4delete2program ['CODE4SOURCE'] = {}
                    task4delete2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] = 'Yes'
                    task4delete2program ['CODE4SOURCE'] [folder2lib4hpu + 'hpu2dummy4xi.py'] = 'Yes'
        
                    task4delete2program ['SIZE4SOURCE'] = {}
                    task4delete2program ['SIZE4SOURCE'] [folder2lib4hpu + 'hpu2buffer4xi.py'] = 'Yes'
                    task4delete2program ['SIZE4SOURCE'] [folder2lib4hpu + 'hpu2dummy4xi.py'] = 'Yes'
                    
                    response4delete2programwithsource = programobject2hpu.delete2programwithsource(task4delete2program)
                    print('(Step 124B/700) OF HPU2PROGRAM4XI5TEST - DELETED SOURCE IN PROGRAM OBJECT WITH CLASS ', time4xi())
                except:
                    print('(Step 124Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO DELETE SOURCE IN PROGRAM OBJECT WITH CLASS *** ', time4xi())    
                try:                                                                                      
                    print('COUNT4SOURCE: ', response4delete2programwithsource['COUNT4SOURCE'])
                    print('DIRECTORY4SOURCE: ', response4delete2programwithsource['DIRECTORY4SOURCE'])
                    print('LANGUAGE4SOURCE: ', response4delete2programwithsource['LANGUAGE4SOURCE'])
                    print('SIZE4SOURCE: ', response4delete2programwithsource['SIZE4SOURCE'])
                    keys2source = response4delete2programwithsource['CODE4SOURCE'].keys()
                    for key2source in keys2source:
                        print('SOURCE: ', key2source)
                        print(response4delete2programwithsource ['CODE4SOURCE'] [key2source] [1])
                    # COUNT4SOURCE:  1
                    # DIRECTORY4SOURCE:  OK 
                    # LANGUAGE4SOURCE:  Python
                    # SIZE4SOURCE:  {'... hpu2sampler4xi5test.py': 1337}
                    # SOURCE:  ... hpu2sampler4xi5test.py
                    # #<profile4xi profile = "11" />                        
                except:
                    print('(Step 124Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4delete2programwithsource *** ', response4delete2programwithsource)                    
            else:
                pass
                                                                                                                # NOT IN FOCUS
            print('FOCUS 130')                                                        
            if KB4Focus['create2programwithbinary'] == 'NACK4XI':                                                                                                                                                        
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS                          
                # ---------------------------------------------------------------------------------------------
                print('(Step 130A/700) OF HPU2PROGRAM4XI5TEST - CREATING WITH BINARY PROGRAM FOR HPU', time4xi())      
                try:
                    # ---------------------------------------------------------------------------------------------
                    # CREATE BINARY                         
                    # ---------------------------------------------------------------------------------------------        
                    response4create2programwithbinary = programobject2hpu.create2programwithbinary()
                    print('(Step 130A/700) OF HPU2PROGRAM4XI5TEST - CREATED WITH BINARY PROGRAM FOR HPU', time4xi())
                except:
                    print('(Step 130Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO CREATE  WITH BINARY PROGRAM FOR HPU')  
                try:                                                                                          
                    keys2response = response4create2programwithbinary.keys()
                    print('COUNT2REFERENCE:', response4create2programwithbinary ['COUNT2REFERENCE'])   
                    print('COUNT4BINARY:', response4create2programwithbinary ['COUNT4BINARY'])
                    print('DIRECTORY4BINARY:', response4create2programwithbinary ['DIRECTORY4BINARY']) 
                    print('FUNCTION2CALLBACK:', response4create2programwithbinary ['FUNCTION2CALLBACK'])   
                    print('LANGUAGE4BINARY:', response4create2programwithbinary ['LANGUAGE4BINARY'])
                    print('SIZE4BINARY:', response4create2programwithbinary ['SIZE4BINARY'])                
                    #
                    keys2source = response4create2programwithbinary['CODE4BINARY'].keys()
                    for key2source in keys2source:
                        print('BINARY: ', key2source)
                        print(response4create2programwithbinary ['CODE4BINARY'] [key2source] [1])
                    # COUNT2REFERENCE: 1
                    # COUNT4BINARY: 1
                    # DIRECTORY4BINARY: folder2lib4hpu + __pycache__//
                    # FUNCTION2CALLBACK: <function trace2program4hpu at 0x000000000415CBC8>
                    # LANGUAGE4BINARY: Python
                    # SIZE4BINARY: {'folder2lib4hpu + '__pycache__//hpu2image4xi.cpython-33.pyc': 1006}
                    # BINARY:  folder2lib4hpu + __pycache__//hpu2image4xi.cpython-33.pyc
                    # b'l\x0c\r\n'
                except:
                    print('(Step 130Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4CREATE2PROGRAMWITHBINARY : ', response4create2programwithbinary)                                        
            else:
                pass                                                                                                # NOT IN FOCUS
            
            print('FOCUS 132')         
            if KB4Focus['add2programwithbinary'] == 'NACK4XI':       
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - ADD BINARY INTO PROGRAM OBJECT WITH METHOD                          
                # ---------------------------------------------------------------------------------------------    
                print('(Step 132A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO ADD BINARY INTO PROGRAM OBJECT WITH METHOD ', time4xi())         
                try:
                    task4add2program = {}
                    task4add2program ['CODE4BINARY'] = {}
                    task4add2program ['SIZE4BINARY'] = {}            
                    # NOT OK - EXISTS
                    task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu2image4xi.cpython-33.pyc'] = {}
                    task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu2image4xi.cpython-33.pyc'] [1] = b'l\x0c\r\n'
                    task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu2image4xi.cpython-33.pyc'] [2] = b'l\x0c\z\n' 
                    task4add2program ['SIZE4BINARY'] [folder2lib4hpu + '__pycache__//hpu2image4xi.cpython-33.pyc'] = len(task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu2image4xi.cpython-33.pyc'])
                             
                    # OK
                    task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'] = {}
                    task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'] [1] = b'l\x0c\r\n'
                    task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'] [2] = b'l\x0c\z\n' 
                    task4add2program ['SIZE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'] = len(task4add2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'])
                    
                    response4add2programwithbinary = programobject2hpu.add2programwithbinary(task4add2program) 
                    print('(Step 132B/700) OF HPU2PROGRAM4XI5TEST - ADDED BINARY INTO PROGRAM OBJECT WITH METHOD ', time4xi())
                except:
                    print('(Step 132Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO ADD BINARY INTO PROGRAM OBJECT WITH METHOD *** ', time4xi())
                try:                                                                                          
                    keys2response = response4add2programwithbinary.keys()
                    print('COUNT2REFERENCE:', response4add2programwithbinary ['COUNT2REFERENCE'])   
                    print('COUNT4BINARY:', response4add2programwithbinary ['COUNT4BINARY'])
                    print('DIRECTORY4BINARY:', response4add2programwithbinary ['DIRECTORY4BINARY']) 
                    print('FUNCTION2CALLBACK:', response4add2programwithbinary ['FUNCTION2CALLBACK'])   
                    print('LANGUAGE4BINARY:', response4add2programwithbinary ['LANGUAGE4BINARY'])
                    print('SIZE4BINARY:', response4add2programwithbinary ['SIZE4BINARY'])                
                    # 
                    keys2source = response4add2programwithbinary['CODE4BINARY'].keys()
                    for key2source in keys2source:
                        print('BINARY: ', key2source)
                        print(response4add2programwithbinary ['CODE4BINARY'] [key2source] [1])
                    # COUNT2REFERENCE: 1
                    # COUNT4BINARY: 2
                    # DIRECTORY4BINARY: ... //__pycache__//
                    # FUNCTION2CALLBACK: <function trace2program4hpu at 0x000000000419BBC8>
                    # LANGUAGE4BINARY: Python
                    # SIZE4BINARY: {'...//__pycache__//hpu2image4xi.cpython-33.pyc': 1006, '...//__pycache__//hpu3image4xi.cpython-33.pyc': 2}
                    # BINARY:  ...__pycache__//hpu2image4xi.cpython-33.pyc
                    # b'l\x0c\r\n'
                    # BINARY:  ...//__pycache__//hpu3image4xi.cpython-33.pyc
                    # b'l\x0c\r\n'       
                except:
                    print('(Step 132Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4ADD2PROGRAMWITHBINARY : ', response4add2programwithbinary) 
            else:
                pass                                                                                                # NOT IN FOCUS
           
            print('FOCUS 134')              
            if KB4Focus['delete2programwithbinary'] == 'NACK4XI':     
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - DELETE BINARY INSIDE PROGRAM OBJECT WITH METHOD                          
                # ---------------------------------------------------------------------------------------------    
                print('(Step 134A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO DELETE BINARY INSIDE PROGRAM OBJECT WITH METHOD ', time4xi())        
                try:
                    task4delete2program = {}
                    task4delete2program ['CODE4BINARY'] = {}
                    task4delete2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'] = 'Yes'
                    task4delete2program ['CODE4BINARY'] [folder2lib4hpu + '__pycache__//dummy3image4xi.cpython-33.pyc'] = 'Yes'
        
                    task4delete2program ['SIZE4BINARY'] = {}
                    task4delete2program ['SIZE4BINARY'] [folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'] = 'Yes'
                    task4delete2program ['SIZE4BINARY'] [folder2lib4hpu + '__pycache__//dummy3image4xi.cpython-33.pyc'] = 'Yes'
                    
                    response4delete2programwithbinary = programobject2hpu.delete2programwithbinary(task4delete2program)
                    print('(Step 134B/700) OF HPU2PROGRAM4XI5TEST - DELETED BINARY INSIDE PROGRAM OBJECT WITH METHOD ', time4xi())                                                                  
                except:
                    print('(Step 134Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO DELETE BINARY INSIDE PROGRAM OBJECT WITH METHOD *** ', time4xi())
                try:                                                                                          
                    keys2response = response4delete2programwithbinary.keys()
                    print('COUNT2REFERENCE:', response4delete2programwithbinary ['COUNT2REFERENCE'])   
                    print('COUNT4BINARY:', response4delete2programwithbinary ['COUNT4BINARY'])
                    print('DIRECTORY4BINARY:', response4delete2programwithbinary ['DIRECTORY4BINARY']) 
                    print('FUNCTION2CALLBACK:', response4delete2programwithbinary ['FUNCTION2CALLBACK'])   
                    print('LANGUAGE4BINARY:', response4delete2programwithbinary ['LANGUAGE4BINARY'])
                    print('SIZE4BINARY:', response4delete2programwithbinary ['SIZE4BINARY'])                
                    # 
                    keys2source = response4delete2programwithbinary['CODE4BINARY'].keys()
                    for key2source in keys2source:
                        print('BINARY: ', key2source)
                        print(response4delete2programwithbinary ['CODE4BINARY'] [key2source] [1])
                    # COUNT2REFERENCE: 1
                    # COUNT4BINARY: 1
                    # DIRECTORY4BINARY: ...//__pycache__//
                    # FUNCTION2CALLBACK: <function trace2program4hpu at 0x000000000412BBC8>
                    # LANGUAGE4BINARY: Python
                    # SIZE4BINARY: {'...//__pycache__//hpu2image4xi.cpython-33.pyc': 1006}
                    # BINARY:  ...__pycache__//hpu2image4xi.cpython-33.pyc
                    # b'l\x0c\r\n'
                                    
                except:
                    print('(Step 134Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4delete2programwithbinary : ', response4delete2programwithbinary)   
            else:
                pass                                                                                                # NOT IN FOCUS
            
            print('FOCUS 140')                          
            if KB4Focus['get2programinfo'] == 'NACK4XI':                 
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - GET METHOD                  
                # ---------------------------------------------------------------------------------------------          
                task4getinfo2program = {}
                task4getinfo2program ['COUNT4SOURCE'] = 'Yes'
                task4getinfo2program ['DIRECTORY4SOURCE'] = 'Yes'
                task4getinfo2program ['CODE4SOURCE'] = 'Yes'
                task4getinfo2program ['SIZE4SOURCE'] = 'Yes'
                task4getinfo2program ['LANGUAGE4SOURCE'] = 'Yes'
                task4getinfo2program ['COUNT4BINARY'] = 'Yes'
                task4getinfo2program ['DIRECTORY4BINARY'] = 'Yes'
                task4getinfo2program ['CODE4BINARY'] = 'Yes'
                task4getinfo2program ['SIZE4BINARY'] = 'Yes'
                task4getinfo2program ['LANGUAGE4BINARY'] = 'Yes'
                response4getinfo2program = {}
                print('(Step 140A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO GET SELECTED PROGRAM INFO OF HPU DEVICE ', time4xi())    
                # 
                try:                               
                    response4getinfo2program = programobject2hpu.get2programinfo(task4getinfo2program)
                    print('(Step 140B/700) OF HPU2PROGRAM4XI5TEST - GOT SELECTED PROGRAM INFO OF HPU DEVICE ', time4xi()) 
                except:
                    print('(Step 140Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO GET SELECTED PROGRAM INFO OF HPU DEVICE ', time4xi()) 
                try:                                                                                          
                    keys2response = response4getinfo2program.keys()
                    print('COUNT2REFERENCE:', response4getinfo2program ['COUNT2REFERENCE'])
                except:
                    pass
                try:           
                    print('COUNT4BINARY:', response4getinfo2program ['COUNT4BINARY'])
                except:
                    pass
                try:                        
                    print('DIRECTORY4BINARY:', response4getinfo2program ['DIRECTORY4BINARY'])
                except:
                    pass
                try:         
                    print('FUNCTION2CALLBACK:', response4getinfo2program ['FUNCTION2CALLBACK'])   
                except:
                    pass
                try:        
                    print('LANGUAGE4BINARY:', response4getinfo2program ['LANGUAGE4BINARY'])
                except:    
                    print('SIZE4BINARY:', response4getinfo2program ['SIZE4BINARY'])                
                try:    
                    keys2binary = response4getinfo2program['CODE4BINARY'].keys()
                    for key2binary in keys2binary:
                        print('BINARY: ', key2binary)
                        print(response4getinfo2program ['CODE4BINARY'] [key2binary] [1])
                        #                
                except:
                    pass
                try:    
                    keys2source = response4getinfo2program['CODE4SOURCE'].keys()
                    for key2source in keys2source:
                        print('SOURCE: ', key2source)
                        print(response4getinfo2program ['CODE4SOURCE'] [key2source] [1])
                        #                
                except:
                    pass 
                    # COUNT4BINARY: 1
                    # DIRECTORY4BINARY: ...//__pycache__//
                    # LANGUAGE4BINARY: Python
                    # BINARY:  ...//__pycache__//hpu2image4xi.cpython-33.pyc
                    # b'l\x0c\r\n'                                       
            else:
                pass                                                                                                # NOT IN FOCUS
                
            print('FOCUS 150')                        
            if KB4Focus['set2programwithsource'] == 'NACK4XI':
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - SET METHOD            
                # ---------------------------------------------------------------------------------------------    
                print('(Step 150A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET PROGRAM ', time4xi())
                    
                # ---------------------------------------------------------------------------------------------
                # (4) INITIALIZE TASK DICTIONARY                         
                # ---------------------------------------------------------------------------------------------            
                task4set2program = {}
            
            
                # ---------------------------------------------------------------------------------------------
                # (5) DEFINE CONTEXT - REQUIRED                           
                # ---------------------------------------------------------------------------------------------         
            
                task4set2program  ['CONTEXT'] = create2context4hpu()  
            
                
                # ---------------------------------------------------------------------------------------------
                # (6) DEFINE DEVICE - EXTRA                           
                # ---------------------------------------------------------------------------------------------         
            
                task4set2program  ['DEVICE'] = init2hpu4xi()  
                                  
            
                # ---------------------------------------------------------------------------------------------
                # (7) DEFINE ERROR CODE - REQUIRED                            
                # ---------------------------------------------------------------------------------------------         
                task4set2program  ['CODE2ERROR'] = 0 
            
                
                # ---------------------------------------------------------------------------------------------
                # (8) QUEUE - EXTRA                            
                # ---------------------------------------------------------------------------------------------         
                print('(Step 152A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET QUEUE4XI ', time4xi()) 
                task4set2program  ['QUEUE'] = None
                try:
                    task4set2program  ['QUEUE'] = Queue4Xi() 
                    print('(Step 152B/700) OF HPU2PROGRAM4XI5TEST - QUEUE : ', task4set2program  ['QUEUE']) 
                    # <queue4xi.Queue4Xi object at 0x0000000003D91E10>
                    
                except:
                    print('(Step 152Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO CREATE QUEUE4XI ', time4xi()) 
                        
                # ---------------------------------------------------------------------------------------------
                # (9) PIPE                           
                # ---------------------------------------------------------------------------------------------         
                print('(Step 154A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET PIPE4XI ', time4xi()) 
                task4set2program  ['PIPE'] = None
                try:
                    task4set2program  ['PIPE'] = Pipe4Xi() 
                    print('(Step 154B/700) OF HPU2PROGRAM4XI5TEST - PIPE : ', task4set2program  ['PIPE'])
                    # (<read-write PipeConnection, handle 548>, <read-write PipeConnection, handle 552>)
                    
                except:
                    print('(Step 154Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET PIPE4XI ', time4xi()) 
                
                # ---------------------------------------------------------------------------------------------
                # (10) SET COMMAND QUEUE - EXTRA                            
                # ---------------------------------------------------------------------------------------------         
                task4set2program ['COMMANDQUEUE'] = None
                print('(Step 156A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET COMMAND QUEUEFOR PROGRAM4HPU ', time4xi())   
                try:                               
                    task4set2program ['COMMANDQUEUE'] = create2commandqueue4hpu()                                                                                                                    
                    print('(Step 156B/700) OF HPU2PROGRAM4XI5TEST - COMMAND QUEUE OF PROGRAM4HPU: ', task4set2program ['COMMANDQUEUE'])                           
                    # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
                    
                    
                except:
                    print('(Step 156Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR PROGRAM4HPU ', time4xi())
                      
                # ---------------------------------------------------------------------------------------------
                # (11) SET SOURCE LANGUAGE                           
                # ---------------------------------------------------------------------------------------------         
                
                print('(Step 158A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET LANGUAGE FOR PROGRAM4HPU ', time4xi())   
                try:                               
                    task4set2program ['LANGUAGE4SOURCE'] = 'C99'                                                                                                                  
                    print('(Step 158B/700) OF HPU2PROGRAM4XI5TEST - LANGUAGE OF PROGRAM4HPU: ', task4set2program ['LANGUAGE4SOURCE'])                           
                    # C99
                    
                    
                except:
                    print('(Step 158Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET LANGUAGE FOR PROGRAM4HPU ', time4xi())  
                    
                        
                # ---------------------------------------------------------------------------------------------
                # (12) SET COUNT4SOURCE              
                # ---------------------------------------------------------------------------------------------         
                print('(Step 12A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET COUNT4SOURCE FOR PROGRAM4HPU ', time4xi())    
                try:                               
                    task4set2program ['COUNT4SOURCE'] = int(len(kb2fetch4hpu)/2)                                                                                                               
                    print('(Step 12B/700) OF HPU2PROGRAM4XI5TEST - COUNT4SOURCE OF PROGRAM4HPU: ', task4set2program ['COUNT4SOURCE'])                           
                    # 1
                    
                except:
                    print('(Step 12Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET COUNT4SOURCE FOR PROGRAM4HPU ', time4xi())  
                    
                
                # ---------------------------------------------------------------------------------------------
                # (14) SET DIRECTORY4SOURCE                       
                # ---------------------------------------------------------------------------------------------         
                print('(Step 14A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET DIRECTORY4SOURCE FOR PROGRAM4HPU ', time4xi())    
                try: 
                         
                    task4set2program ['DIRECTORY4SOURCE'] = folder2lib4hpu                                                                                                          
                    print('(Step 14B/700) OF HPU2PROGRAM4XI5TEST - DIRECTORY4SOURCE OF PROGRAM4HPU: ', task4set2program ['DIRECTORY4SOURCE'])                            
                    # folder2lib4hpu
                    
                except:
                    print('(Step 14Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET DIRECTORY4SOURCE FOR PROGRAM4HPU ', time4xi())  
                        
                
                # ---------------------------------------------------------------------------------------------
                # (16) SET LANGUAGE4SOURCE                       
                # ---------------------------------------------------------------------------------------------         
                task4set2program ['LANGUAGE4SOURCE'] = None
                print('(Step 16A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET LANGUAGE4SOURCE FOR PROGRAM4HPU ', time4xi())    
                try:                               
                    task4set2program ['LANGUAGE4SOURCE'] = "Python"                                                                                                                   
                    print('(Step 16B/700) OF HPU2PROGRAM4XI5TEST - LANGUAGE4SOURCE OF PROGRAM4HPU: ', task4set2program ['LANGUAGE4SOURCE'])                           
                    # Python
                    
                except:
                    print('(Step 16Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET LANGUAGE4SOURCE FOR PROGRAM4HPU ', time4xi())  
                    
                
                
                # ---------------------------------------------------------------------------------------------
                # (18) SET CODE4SOURCE                       
                # ---------------------------------------------------------------------------------------------         
                task4set2program ['CODE4SOURCE'] = None
                print('(Step 18A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET SOURCE OF TASK FOR PROGRAM4HPU  ', time4xi())     
                try: 
                    source4hpu = {}
                    key2source4hpu = folder2lib4hpu + 'hpu2image4xi5test.py'
                    code2source4hpu = {}
                    code2source4hpu [1] = '#<profile4xi profile = "11" />\n'
                    code2source4hpu [2] = '#<program4xi program = "hpu2image4xi5test.py">\n'
                    
                    source4hpu [key2source4hpu] = code2source4hpu
                                              
                    task4set2program ['CODE4SOURCE'] = source4hpu                                                                                                              
                    print('(Step 18B/700) OF HPU2PROGRAM4XI5TEST - SET SOURCE OF TASK FOR PROGRAM4HPU TO: ', task4set2program ['CODE4SOURCE'])                           
                    # {folder2lib4hpu + 'hpu2image4xi5test.py': {1: '#<profile4xi profile = "11" />\n', 2: '#<program4xi program = "hpu2image4xi5test.py">\n'}}
        
                except:
                    print('(Step 18Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET SOURCE OF TASK FOR PROGRAM4HPU  ', time4xi()) 
                
                # ---------------------------------------------------------------------------------------------
                # (19) SET SIZE4SOURCE             
                # ---------------------------------------------------------------------------------------------         
                task4set2program ['SIZE4SOURCE'] = 0
                print('(Step 19A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET SOURCE OF TASK FOR PROGRAM4HPU  ', time4xi())     
                try: 
                    task4set2program ['SIZE4SOURCE'] = len(source4hpu)                                                                                                              
                    print('(Step 19B/700) OF HPU2PROGRAM4XI5TEST - SET SIZE OF SOURCE OF TASK FOR PROGRAM4HPU TO: ', task4set2program ['SIZE4SOURCE'])                           
                    # 
        
                except:
                    print('(Step 19Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET SOURCE OF TASK FOR PROGRAM4HPU  ', time4xi()) 
                                                                                 
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - SET PROGRAM SOURCE WITH METHOD FINALLY!                  
                # ---------------------------------------------------------------------------------------------     
                print('(Step 158A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET PROGRAM SOURCE FOR HPU: ', time4xi())      
                try: 
                    response4set2program = programobject2hpu.set2programwithsource(task4set2program)
                    print('(Step 158B/700) OF HPU2PROGRAM4XI5TEST - SET PROGRAM SOURCE FOR HPU: ', time4xi())    
                except:
                    print('(Step 158Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET PROGRAM SOURCE FOR HPU: ', time4xi())
                try:                                                                                          
                    keys2response = response4set2program.keys()
                    print('COUNT2REFERENCE:', response4set2program ['COUNT2REFERENCE'])   
                    print('COUNT4SOURCE:', response4set2program ['COUNT4SOURCE'])
                    print('DIRECTORY4SOURCE:', response4set2program ['DIRECTORY4SOURCE']) 
                    print('FUNCTION2CALLBACK:', response4set2program ['FUNCTION2CALLBACK'])   
                    print('LANGUAGE4SOURCE:', response4set2program ['LANGUAGE4SOURCE'])
                    print('SIZE4SOURCE:', response4set2program ['SIZE4SOURCE'])                
    
                    keys2source = response4set2program['CODE4SOURCE'].keys()
                    for key2source in keys2source:
                        print('SOURCE: ', key2source)
                        print(response4set2program ['CODE4SOURCE'] [key2source] [1])
                    # COUNT2REFERENCE: 1
                    # COUNT4SOURCE: 1
                    # DIRECTORY4SOURCE: OK
                    # FUNCTION2CALLBACK: <function trace2program4hpu at 0x0000000003AC5BC8>
                    # LANGUAGE4SOURCE: Python
                    # SIZE4SOURCE: 1
                    # SOURCE:  ... //hpu2image4xi5test.py
                    # #<profile4xi profile = "11" />        
                except:
                    print('(Step 158Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4set2program : ', response4set2program)  
            else:
                pass                                                                                                # NOT IN FOCUS
            
            print('FOCUS 160')         
            if KB4Focus['set2programwithbinary'] == 'NACK4XI':    
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - SET PROGRAM BINARY WITH METHOD                         
                # ---------------------------------------------------------------------------------------------         
                task4set2programwithbinary = {}
                # ---------------------------------------------------------------------------------------------
                # (162) SET DIRECTORY4BINARY                       
                # ---------------------------------------------------------------------------------------------         
                print('(Step 162A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET DIRECTORY4BINARY FOR PROGRAM4HPU ', time4xi())    
                try: 
                    task4set2programwithbinary ['DIRECTORY4BINARY'] = folder2lib4hpu + "__pycache__//"                                                                                                           
                    print('(Step 162B/700) OF HPU2PROGRAM4XI5TEST - DIRECTORY4BINARY OF PROGRAM4HPU: ', task4set2programwithbinary ['DIRECTORY4BINARY'])                           
                    # 
                    
                except:
                    print('(Step 212Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET DIRECTORY4BINARY FOR PROGRAM4HPU ', time4xi())  
                        
                
                # ---------------------------------------------------------------------------------------------
                # (164) SET LANGUAGE4BINARY                       
                # ---------------------------------------------------------------------------------------------         
                task4set2programwithbinary ['LANGUAGE4BINARY'] = None
                print('(Step 164A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET LANGUAGE4BINARY FOR PROGRAM4HPU ', time4xi())    
                try:                               
                    task4set2programwithbinary ['LANGUAGE4BINARY'] = "Python"                                                                                                                   
                    print('(Step 164B/700) OF HPU2PROGRAM4XI5TEST - LANGUAGE4BINARY OF PROGRAM4HPU: ', task4set2programwithbinary ['LANGUAGE4BINARY'])                           
                    # 
                    
                except:
                    print('(Step 164Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET LANGUAGE4BINARY FOR PROGRAM4HPU ', time4xi())  
                    
                
                
                # ---------------------------------------------------------------------------------------------
                # (165) SET CODE4BINARY                       
                # ---------------------------------------------------------------------------------------------         
                task4set2programwithbinary ['CODE4BINARY'] = None
                print('(Step 165A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET BINARY OF TASK FOR PROGRAM4HPU  ', time4xi())     
                try: 
                    binary4hpu = {}
                    key2binary4hpu = folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'
                    code2binary4hpu = {}
                    code2binary4hpu [1] = b'l\x0c\r\n'
                    code2binary4hpu [2] = b'\x00Z\n'
                    
                    binary4hpu [key2binary4hpu] = code2binary4hpu
                                              
                    task4set2programwithbinary ['CODE4BINARY'] = binary4hpu                                                                                                              
                    print('(Step 165B/700) OF HPU2PROGRAM4XI5TEST - SET BINARY OF TASK FOR PROGRAM4HPU TO: ', task4set2programwithbinary ['CODE4BINARY'])                           
                    # {folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc': {1: b'l\x0c\r\n', 2: b'\x00Z\n'}}
        
                except:
                    print('(Step 35Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET BINARY OF TASK FOR PROGRAM4HPU  ', time4xi()) 
                
                # ---------------------------------------------------------------------------------------------
                # (166) SET SIZE4BINARY                       
                # ---------------------------------------------------------------------------------------------         
                task4set2programwithbinary ['SIZE4BINARY'] = 1
                print('(Step 166A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET BINARY OF TASK FOR PROGRAM4HPU  ', time4xi())     
                try: 
                    task4set2programwithbinary ['SIZE4BINARY'] = len(binary4hpu)                                                                                                              
                    print('(Step 166B/700) OF HPU2PROGRAM4XI5TEST - SET SIZE OF BINARY OF TASK FOR PROGRAM4HPU TO: ', task4set2programwithbinary ['SIZE4BINARY'])                           
                    # 1
        
                except:
                    print('(Step 166Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET BINARY OF TASK FOR PROGRAM4HPU  ', time4xi()) 
             
                # ---------------------------------------------------------------------------------------------
                # (167) SET CODE4BINARY                       
                # ---------------------------------------------------------------------------------------------         
                task4set2programwithbinary ['CODE4BINARY'] = None
                print('(Step 167A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET BINARY OF TASK FOR PROGRAM4HPU  ', time4xi())      
                try: 
                    binary4hpu = {}
                    key2binary4hpu = folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'
                    code2binary4hpu = {}
                    code2binary4hpu [1] = b'l\x0c\r\n'
                    code2binary4hpu [2] = b'\x00Z\n'
                    
                    binary4hpu [key2binary4hpu] = code2binary4hpu
                                              
                    task4set2programwithbinary ['CODE4BINARY'] = binary4hpu                                                                                                              
                    print('(Step 167B/700) OF HPU2PROGRAM4XI5TEST - SET BINARY OF TASK FOR PROGRAM4HPU TO: ', task4set2programwithbinary ['CODE4BINARY'])                           
                except:
                    print('(Step 167Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET BINARY OF TASK FOR PROGRAM4HPU  ', time4xi()) 
                    
                print('(Step 167CB/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET BINARY PROGRAM FOR HPU: ', time4xi())      
                try: 
                    response4set2program = programobject2hpu.set2programwithbinary(task4set2programwithbinary)
                    print('(Step 167D/700) OF HPU2PROGRAM4XI5TEST - SET BINARY PROGRAM FOR HPU: ', time4xi())
                except:
                    print('(Step 167Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4SET2PROGRAM: ', response4set2program)                     
                try:                                                                                          
                    keys2response = response4set2program.keys()
                    print('COUNT2REFERENCE:', response4set2program ['COUNT2REFERENCE']) 
                except:
                    pass
                try:        
                    print('COUNT4BINARY:', response4set2program ['COUNT4BINARY'])
                except:
                    pass
                try:        
                    print('DIRECTORY4BINARY:', response4set2program ['DIRECTORY4BINARY']) 
                except:
                    pass
                try:        
                    print('FUNCTION2CALLBACK:', response4set2program ['FUNCTION2CALLBACK'])   
                except:
                    pass
                try:        
                    print('LANGUAGE4BINARY:', response4set2program ['LANGUAGE4BINARY'])
                except:
                    pass
                try:        
                    print('SIZE4BINARY:', response4set2program ['SIZE4BINARY'])                
                except:
                    pass
                try:        
    
                    keys2binary = response4set2program['CODE4BINARY'].keys()
                    for key2binary in keys2binary:
                        print('BINARY: ', key2binary)
                        print(response4set2program ['CODE4BINARY'] [key2binary] [1])
                    #    
                except:
                    pass
                    # COUNT2REFERENCE: 1
                    # DIRECTORY4BINARY: ... //__pycache__//
                    # FUNCTION2CALLBACK: <function trace2program4hpu at 0x0000000003B1FBC8>
                    # LANGUAGE4BINARY: Python
                    # SIZE4BINARY: 1
                    # BINARY:  ... //__pycache__//hpu3image4xi.cpython-33.pyc
                    # b'l\x0c\r\n'                    
            else:
                pass                                                                                                # NOT IN FOCUS                            
                
            print('FOCUS 170')                     
            if KB4Focus['release2program'] == 'NACK4XI':                                                                              
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - RELEASE PROGRAM                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 170A/700) OF HPU2PROGRAM4XI5TEST - RELEASING PROGRAM', time4xi())  
                task4release2program  = {}
                task4release2program  ['COUNT2REFERENCE'] = 1
                try:
                    response4release2program = programobject2hpu.release2program(task4release2program)
                    print('(Step 170B/700) OF HPU2PROGRAM4XI5TEST - RELEASED PROGRAM', time4xi())
                except:
                    print('(Step 170Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO RELEASE PROGRAM', time4xi())                        
                    keys2response = response4release2program.keys()
                try:
                    print('(Step 170C/700) OF HPU2PROGRAM4XI5TEST - COUNT2REFERENCE: ', response4release2program['COUNT2REFERENCE'] )
                    # 0
                except:
                    print('(Step 170Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4RELEASE2PROGRAM', response4release2program)  
            else:
                pass                                                                                                # NOT IN FOCUS
            
            print('FOCUS 180')                 
            if KB4Focus['retain2program'] == 'NACK4XI':                                                                               
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - RETAIN PROGRAM                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 180A/700) OF HPU2PROGRAM4XI5TEST - RETAINING PROGRAM ', time4xi())
                task4retain2program  = {}
                task4retain2program  ['COUNT2REFERENCE'] = 1
                try:
                    response4retain2program = programobject2hpu.retain2program(task4retain2program)
                    print('(Step 180B/700) OF HPU2PROGRAM4XI5TEST - RETAINED PROGRAM ', time4xi())
                except:
                    print('(Step 180Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO RETAIN PROGRAM ', time4xi())                    
                try:
                    print('(Step 180C/700) OF HPU2PROGRAM4XI5TEST COUNT2REFERENCE: ', response4retain2program ['COUNT2REFERENCE'])
                    # 2
                except:
                    print('(Step 180Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4RETAIN2PROGRAM ', response4retain2program)
            else:
                pass                                                                                                # NOT IN FOCUS
            
            print('FOCUS 190')         
            if KB4Focus['create2programwithsource'] == 'NACK4XI':               
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - CREATE AGAIN PROGRAM OBJECT AND USE ITS CREATE METHOD                           
                # ---------------------------------------------------------------------------------------------        
                print('(Step 190A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO CREATE PROGRAM WITH SOURCE FOR HPU ', time4xi()) 
                try:
                    programobject2hpu = HPU2Program4Xi()                            
                    response4create2programwithsource = programobject2hpu.create2programwithsource()
                    print('(Step 190B/700) OF HPU2PROGRAM4XI5TEST - CREATED PROGRAM WITH SOURCE FOR HPU ', time4xi())
                except:
                    print('(Step 190Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO CREATE PROGRAM WITH SOURCE FOR HPU ', time4xi())                                    
                try:                                                                                      
                    print('COUNT4SOURCE: ', response4create2programwithsource['COUNT4SOURCE'])
                    print('DIRECTORY4SOURCE: ', response4create2programwithsource['DIRECTORY4SOURCE'])
                    print('LANGUAGE4SOURCE: ', response4create2programwithsource['LANGUAGE4SOURCE'])
                    print('SIZE4SOURCE: ', response4create2programwithsource['SIZE4SOURCE'])
                    keys2source = response4create2programwithsource['CODE4SOURCE'].keys()
                    for key2source in keys2source:
                        print('SOURCE: ', key2source)
                        print(response4create2programwithsource ['CODE4SOURCE'] [key2source] [1])
                        print(response4create2programwithsource ['CODE4SOURCE'] [key2source] [3])
                        print(response4create2programwithsource ['CODE4SOURCE'] [key2source] [4])
                        print(response4create2programwithsource ['CODE4SOURCE'] [key2source] [5])
                        
                    # COUNT4SOURCE:  1
                    # DIRECTORY4SOURCE:  folder2lib4hpu
                    # LANGUAGE4SOURCE:  Python
                    # SIZE4SOURCE:  {folder2lib4hpu + 'hpu2sampler4xi5test.py': 1337}
                    # SOURCE:  folder2lib4hpu + hpu2sampler4xi5test.py
                    # #<profile4xi profile = "11" />
                    # #<program4xi program = "hpu2sampler4xi5test.py">
                    # #<abstract4xi abstract = "tests hpu2sampler4xi.py"/>
                    # #<verify4xi verification = "11" target = "hpu2sampler4xi.py"/>              
                except:
                    print('(Step 190Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT response4create2programwithsource *** ', response4create2programwithsource)          
            else:
                pass                                                                                                # NOT IN FOCUS
                                                                                     # NOT IN FOCUS
            print('FOCUS 200')         
            if KB4Focus['set2programcallback'] == 'NACK4XI':               
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - SET PROGRAM CALLBACK WITH METHOD                           
                # ---------------------------------------------------------------------------------------------        
                print('(Step 200A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO SET PROGRAM CALLBACK WITH METHOD OF OBJECT XI2HPU: ', programobject2hpu) 
                try:
                    callback2hpu = programobject2hpu.set2programcallback()                                  
                    print('(Step 200B/700) OF HPU2PROGRAM4XI5TEST - SET PROGRAM WITH CALLBACK TO: ', callback2hpu)
                    # <function trace2program4hpu at 0x00000000038E02C8>
                except:
                    print('(Step 200Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SET PROGRAM CALLBACK WITH METHOD ***', time4xi())                  
            else:
                pass                                                                                                # NOT IN FOCUS
                            
            print('FOCUS 210')         
            if KB4Focus['trace2program'] == 'NACK4XI':                                                                                                      
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - TRACE PROGRAMS                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 210A/25) OF HPU2PROGRAM4XI5TEST - TRYING TO TRACE HPU: ', time4xi())      
                trace2hpu = None
                try:
                    trace2hpu = programobject2hpu.trace2program() 
       
                    print('(Step 210B/25) OF HPU2PROGRAM4XI5TEST - TRACE2HPU: ', trace2hpu)  
                    # {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4hpu-failed {}; time: 04:40:24 11/16/11 Pacific Standard Time}', 'CLASS': 'trace2program4hpu', 'METHOD': 'trace2program4hpu'}

                except:
                    print('(Step 210Z1/25) OF HPU2PROGRAM4XI5TEST *** FAILED TO TRACE HPU: ', trace2hpu)     
            else:
                pass                                                                                                # NOT IN FOCUS
                                                                                                                               
            print('FOCUS 220')
            if KB4Focus['release2program'] == 'NACK4XI':
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - RELEASE PROGRAM BY DECREMENTING REFERENCE COUNT WITH 1             
                # ---------------------------------------------------------------------------------------------    
                task4release2program  = {} 
                task4release2program  ['COUNT2REFERENCE'] = 1 
                response4release2program = {}
               
                print('(Step 220A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO RELEASE PROGRAM OF HPU DEVICE ', time4xi())    
                # 
                try:                               
                    response4release2program = programobject2hpu.release2program(task4release2program)                                                                                             
                    print('(Step 220B/700) OF HPU2PROGRAM4XI5TEST - RELEASED PROGRAM OF HPU DEVICE ', time4xi())
                except:
                    print('(Step 220Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO RELEASE PROGRAM OF HPU DEVICE ', time4xi())
                try:                           
                    keys2response = response4release2program.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4release2program[key2response])
                        # COUNT2REFERENCE  :  0
                except:
                    print('(Step 220Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4RELEASE2PROGRAM ', response4release2program)  
                
                task4getinfo2program = {}
                task4getinfo2program ['COUNT2REFERENCE'] = 0
                response4getinfo2program = {}
                print('(Step 220C/700) OF HPU2PROGRAM4XI5TEST - TRYING TO GET SELECTED PROGRAM INFO OF HPU DEVICE ', time4xi())     
                # 
                try:                               
                    response4getinfo2program = programobject2hpu.get2programinfo (task4getinfo2program)
                    print('(Step 220D/700) OF HPU2PROGRAM4XI5TEST - GOT SELECTED PROGRAM INFO OF HPU DEVICE ', time4xi()) 
                except:
                    print('(Step 220Z4/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO GET SELECTED PROGRAM INFO OF HPU DEVICE ', time4xi())
                try:                                                                                                        
                    keys2response = response4getinfo2program.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4getinfo2program[key2response])
                        # COUNT2REFERENCE  :  0
                except:
                    print('(Step 220Z5/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4GETINFO2PROGRAM ', response4getinfo2program)  
            else:
                pass                                                                                                # NOT IN FOCUS
                
            print('FOCUS 230')                                         
            if KB4Focus['retain2program'] == 'NACK4XI':   
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - RETAIN PROGRAM BY DECREASING REFERENCE WITH 1             
                # ---------------------------------------------------------------------------------------------    
                task4retain2program  = {}
                task4retain2program  ['COUNT2REFERENCE'] = 1 
                response4retain2program = {}
                print('(Step 230A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO RETAIN PROGRAM OF HPU DEVICE ', time4xi())   
                try:                               
                    response4retain2program = programobject2hpu.retain2program(task4retain2program)                                                                                                 
                    print('(Step 230B/700) OF HPU2PROGRAM4XI5TEST - RETAINED PROGRAM OF HPU DEVICE ', time4xi()) 
                except:
                    print('(Step 230Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO RETAIN PROGRAM OF HPU DEVICE ', time4xi())
                try:                                       
                    keys2response = response4retain2program.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4retain2program[key2response])
                        # 
                except:
                    print('(Step 230Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4RETAIN2PROGRAM ', response4retain2program)
                    
                task4getinfo2program = {}
                task4getinfo2program ['COUNT2REFERENCE'] = 0
                response4getinfo2program = {}
                print('(Step 230C/700) OF HPU2PROGRAM4XI5TEST - TRYING TO GET SELECTED PROGRAM INFO OF HPU DEVICE ', time4xi())     
                # 
                try:                               
                    response4getinfo2program = programobject2hpu.get2programinfo (task4getinfo2program)
                    print('(Step 230D/700) OF HPU2PROGRAM4XI5TEST - GOT SELECTED PROGRAM INFO OF HPU DEVICE ', time4xi())
                except:
                    print('(Step 230Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO GET SELECTED PROGRAM INFO OF HPU DEVICE ', time4xi())                                                                                                   
                try:
                    keys2response = response4getinfo2program.keys()
              
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4getinfo2program[key2response])
                        # 
                except:
                    print('(Step 230Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT RESPONSE4GETINFO2PROGRAM ', response4getinfo2program)         
            else:
                pass                                                                                                # NOT IN FOCUS
            print('FOCUS 240')         
            if KB4Focus['build2program'] == 'NACK4XI':
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - BUILD PROGRAM                           
                # ---------------------------------------------------------------------------------------------                                                   
                task4build2program  = {}
                task4build2program  ['PROGRAM'] = folder2lib4hpu + 'hpu2sampler4xi.py'
                task4build2program  ['OPTIONS'] = {}
                task4build2program  ['OPTIONS'] ['MATH']          = 'SINGLE-PRECISION-CONSTANT'
                task4build2program  ['OPTIONS'] ['OPTIMIZATION']  = 'DISABLE'
                task4build2program  ['OPTIONS'] ['VERSION']       = 'CL1.1'
                task4build2program  ['OPTIONS'] ['WARNINGS']      = 'INHIBIT'
                print('(Step 240A/700) OF HPU2PROGRAM4XI5TEST - TRYING TO BUILD PROGRAM OF HPU DEVICE ', time4xi())    
                try:                               
                    response4build2program = programobject2hpu.build2program(task4build2program) 
                    print('(Step 240B/700) OF HPU2PROGRAM4XI5TEST - BUILT PROGRAM OF HPU DEVICE ', time4xi())
                except:
                    print('(Step 240Z1/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO BUILD PROGRAM OF HPU DEVICE ', time4xi())
                try:                                                                                                     
                    keys2response = response4build2program.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4build2program[key2response])
                # ACK2RETURN  :   11A1-12A1-
                # NACK2RETURN  :   13Z1-14Z1-
                # OPTIONS  :  {'VERSION': 'CL1.1', 'OPTIMIZATION': 'DISABLE', 'MATH': 'SINGLE-PRECISION-CONSTANT', 'WARNINGS': 'INHIBIT'}
                # PROGRAM  :  folder2lib4hpu + hpu2sampler4xi.py                
                except:
                    print('(Step 240Z2/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO PRINT ', response4build2program)            
            else:
                pass                                                                                                # NOT IN FOCUS
            
            print('FOCUS 310')         
            if KB4Focus['sense'] == 'NACK4XI':
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - SENSE PROGRAM                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 310A/700) OF HPU2PROGRAM4XI5TEST - SENSING ', time4xi())  
                try:
                    print(programobject2hpu.sense())
                    print('(Step 310B/700) OF HPU2PROGRAM4XI5TEST - SENSED ', time4xi()) 
                    # {'object': <hpu2program4xi.HPU2Program4Xi object at 0x0000000003E00AC8>, 'classvariable2hpu-of-HPU2Program4Xi': 4}
                except:
                    print('(Step 310Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO SENSE ', time4xi())          
            else:
                pass                                                                                                # NOT IN FOCUS
            
            print('FOCUS 320')          
            if KB4Focus['reason'] == 'NACK4XI':    
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - REASON PROGRAM                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 320A/700) OF HPU2PROGRAM4XI5TEST - REASONING ', time4xi())
                try:
                    print(programobject2hpu.reason())
                    print('(Step 320B/700) OF HPU2PROGRAM4XI5TEST - REASONED ', time4xi())
                    # HPU2Program4Xi-reasoned-by-reason-of-HPU2Program4Xi: <class 'hpu2program4xi.HPU2Program4Xi'>; time: 04:40:25 11/16/11 Pacific Standard Time}
                except:
                    print('(Step 320Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO REASON ', time4xi()) 
            else:
                pass                                                                                                # NOT IN FOCUS
            
            print('FOCUS 330')                                                    
            if KB4Focus['ace'] == 'NACK4XI':         
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - ACE PROGRAM                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 330A/700) OF HPU2PROGRAM4XI5TEST - ACING ', time4xi())   
                try:
                    print(programobject2hpu.ace())
                    print('(Step 330B/700) OF HPU2PROGRAM4XI5TEST - ACED ', time4xi())                                                 
                    # {'object-reason-object4xi': <hpu2program4xi.HPU2Program4Xi object at 0x0000000003E00AC8>, 'time-reason-of-HPU2Program4Xi': '04:40:25 11/16/11 Pacific Standard Time'}
                except:
                    print('(Step 330Z/700) OF HPU2PROGRAM4XI5TEST *** FAILED TO ACE ', time4xi())
            else:
                pass                                                                                                # NOT IN FOCUS
                                                                    
        else:
            pass                                                                                                    # CLASS NOT IN FOCUS 
             
        # ---------------------------------------------------------------------------------------------
        # DONE - ALL TESTS                          
        # ---------------------------------------------------------------------------------------------    
        print('(Step 700/700) OF HPU2PROGRAM4XI5TEST - DONE! ', time4xi())
    except:
        print('(Step 175/700) OF HPU2PROGRAM4XI5TEST *** FAILED ****  ', time4xi())
    finally:            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(t2xi)        
           
      
#</function4xi>            
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function for hpu2program4xi5test
#"> 
# -------------------------------------------------------------------------------------------------    
def main():
    print("(Step 0A/700) OF HPU2PROGRAM4XI5TEST - SENSING IT WITH YOURHPUXI!", time4xi())   

    hpu2program4xi5test()  

    print("(Step 0B/700) OF HPU2PROGRAM4XI5TEST - SENSED IT WITH YOURHPUXI!", time4xi()) 
    # 
                          
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# hpu2program4xi5test.txt
# sense-hpu2program4xi5test.xml
# reason-hpu2program4xi5test.xml
# ace-hpu2program4xi5test.xml
#" 
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of hpu2program4xi5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/> 
